#ifndef _SPHERE_SOLVER_BC_H_
#define _SPHERE_SOLVER_BC_H_

#include "SklSolverBase.h"
#include "SklUtil.h"
#include "MaterialTable.h"

#define D_MAX_MAT_PARAM  100

//
// class BC
//
class BC
{
public:
  BC();
  virtual ~BC();

public:  
  char m_name[100];
  int m_id;
  int m_MatType;   //0:material, 1:ALL, 2:Fluid, 3:Solid
  Material *m_mat; //material data pointor
  int m_face;      //0:X_MINUS, 1:Y_MINUS, 2:Z_MINUS, 3:X_PLUS, 4:Y_PLUS, 5:Z_PLUS, 6:SVXID;
  int m_svxID;


protected:


public:
  virtual bool ParseBC( const CfgElem *bc_elem, MaterialTable *mt );
  virtual bool print(FILE *fp){ return false; };
};

//
//  class BCvel
//
class BCvel : public BC
{
public:
  BCvel();
  virtual ~BCvel();

public:
  SKL_REAL m_v[3];

public:
  virtual bool ParseBC( const CfgElem *bc_elem, MaterialTable *mt );
  virtual bool print(FILE *fp);
};

//
//  class BCp
//
class BCp : public BC
{
public:
  BCp();
  virtual ~BCp();

public:
  SKL_REAL m_p;

public:
  virtual bool ParseBC( const CfgElem *bc_elem, MaterialTable *mt );
  virtual bool print(FILE *fp);
};

#endif /*_SPHERE_SOLVER_BC_H_*/

