/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2008
 *
 */

#ifndef _SKL_FORTRAN_FUNC_SPH3D_H_
#define _SKL_FORTRAN_FUNC_SPH3D_H_
#include "Skl.h"

extern "C" {
/* USER WRITE
   if using fortran subroutine,
   Please write fortran subroutine here.
   # The function described here belongs to the name scope of C.
   # Therefore, The identifier of Solver is recommended to be added to
   # the function name to distinguish from other functions.
*/

  void
  init_(int *ipara, int *nID, int *ID, int *ni, int *nj, int *nk, int *vc,
        SKL_REAL *rnu00, SKL_REAL *dx  , SKL_REAL *dy , SKL_REAL *dz  , SKL_REAL *wl,
        SKL_REAL *phi  , SKL_REAL *phio, SKL_REAL *uvw, SKL_REAL *uvwo, SKL_REAL *p,
        SKL_REAL *sg   , SKL_REAL *sgo , SKL_REAL *bl , SKL_REAL *blo ,
        SKL_REAL *grav , SKL_REAL *guvw, double *ftime);

  void
  initg_(int* vc,int* ni,int* nj,int* nk,
         SKL_REAL* dx, SKL_REAL* dy, SKL_REAL* dz,
         SKL_REAL* uvw,
         int* id, int* ng, int* nid,
         SKL_REAL* ug, SKL_REAL* vg, SKL_REAL* wg,
         SKL_REAL* xg, SKL_REAL* yg, SKL_REAL* zg );

  void
  caldt_(int *ID,int *vc,int *ni,int *nj,int *nk,int *imon_t,int *nstep,
         SKL_REAL *rnu00,SKL_REAL *gmd00,SKL_REAL *cfl,SKL_REAL *dt,SKL_REAL *time,
         SKL_REAL *dx,SKL_REAL *dy,SKL_REAL *dz,SKL_REAL *uvw,
         SKL_REAL *REAL_MAX,SKL_REAL *rlog,double *ftime);

  void
  solphi_(int *ipara,int *nID,int *ID,int *vsall,int *vc,int *ni,int *nj,int *nk,
          int *icherr,int *nstep,int *imon_t,
          SKL_REAL *time,SKL_REAL *dt,SKL_REAL *dx,SKL_REAL *dy,SKL_REAL *dz,
          SKL_REAL *phi,SKL_REAL *phio,SKL_REAL *phin,SKL_REAL *uvw,SKL_REAL *uvwo,
          SKL_REAL *REAL_MIN,SKL_REAL *rlog,double *ftime);

  void
  solu_(int *ipara,int *ID,int *nID,int *vsall,int *ni,int *nj,int *nk,int *vc,
        int *imax,int *icherr,int *nstep,int *imon_t,
        int *isor,int *itersor,SKL_REAL *sorbeta,SKL_REAL *soreps,
        SKL_REAL *pi,SKL_REAL *time,SKL_REAL *dt,SKL_REAL *dx,SKL_REAL *dy,SKL_REAL *dz,
        SKL_REAL *grv,SKL_REAL *rnu00,SKL_REAL *gmd00,SKL_REAL *xl,SKL_REAL *yl,SKL_REAL *zl,
        SKL_REAL *uvw,SKL_REAL *uvwo,SKL_REAL *uvwn,SKL_REAL *p,SKL_REAL *phin,SKL_REAL *div,
        SKL_REAL *sg,SKL_REAL *sgn,SKL_REAL *bl,SKL_REAL *blo,SKL_REAL *bln,
        SKL_REAL *advsx,SKL_REAL *advsy,SKL_REAL *advsz,SKL_REAL *pk,
        SKL_REAL *work,int *nw,
        int *idx_si,int *idx_sj,int *idx_sk,int *buffsz,
        SKL_REAL *recvib,SKL_REAL *recvjb,SKL_REAL *recvkb,
        SKL_REAL *sendib,SKL_REAL *sendjb,SKL_REAL *sendkb,
        SKL_REAL *REAL_MIN,SKL_REAL *rlog,int *ilog,double *ftime,int *itersort);

  void
  solu1_(int *ipara,int *ID,int *nID,int *ni,int *nj,int *nk,int *vc,
         SKL_REAL *dx,SKL_REAL *dy,SKL_REAL *dz,SKL_REAL *dt,SKL_REAL *grv,
         SKL_REAL *uvw,SKL_REAL *uvwo,SKL_REAL *uvwn,SKL_REAL *p,SKL_REAL *pk,SKL_REAL *sg,SKL_REAL *sgn,
         SKL_REAL *bl,SKL_REAL *blo,SKL_REAL *bln,SKL_REAL *advsx,SKL_REAL *advsy,SKL_REAL *advsz,
         double *ftime,SKL_REAL *REAL_MIN);

  void
  solu2_(int *ipara,int *ID,int *nID,int *vsall,int *ni,int *nj,int *nk,int *vc,
         int *imax,int *nstep,int *icherr,int *imon_t,SKL_REAL *dx,SKL_REAL *dy,SKL_REAL *dz,
         SKL_REAL *dt,SKL_REAL *time,SKL_REAL *rnu00,SKL_REAL *gmd00,
         SKL_REAL *phin,SKL_REAL *uvw,SKL_REAL *uvwn,SKL_REAL *bln,SKL_REAL *sgn,
         SKL_REAL *advsx,SKL_REAL *advsy,SKL_REAL *advsz,
         double *ftime,SKL_REAL *rlog);

  void
  solu3_(int *ipara,int *ID,int *nID,int *sz,int *ni,int *nj,int *nk,int *vc,
         SKL_REAL *dx,SKL_REAL *dy,SKL_REAL *dz,
         SKL_REAL *xl,SKL_REAL *yl,SKL_REAL *zl,int *nstep,SKL_REAL *time,SKL_REAL *dt,
         SKL_REAL *rnu00,SKL_REAL *pi,
         int *isor,int *itersor,SKL_REAL *sorbeta,SKL_REAL *soreps,
         int *idx_si,int *idx_sj,int *idx_sk,int *buffsz,
         SKL_REAL *recvib,SKL_REAL *recvjb,SKL_REAL *recvkb,
         SKL_REAL *sendib,SKL_REAL *sendjb,SKL_REAL *sendkb,
         SKL_REAL *div,SKL_REAL *p,SKL_REAL *pk,SKL_REAL *phin,
         SKL_REAL *uvwn,SKL_REAL *sgn,SKL_REAL *work,int *nw,
         int *icherr,int *imon_t,int *itersort,SKL_REAL *rlog,int *ilog,double *ftime,
         SKL_REAL *REAL_MIN);

  void
  tadv_(int *vc,int *ni,int *nj,int *nk,
        SKL_REAL *uvw,SKL_REAL *uvwn,SKL_REAL *uvwo,
        SKL_REAL *phi,SKL_REAL *phin,SKL_REAL *phio,
        SKL_REAL *sg ,SKL_REAL *sgn ,SKL_REAL *sgo ,
        SKL_REAL *bl ,SKL_REAL *bln ,SKL_REAL *blo);

  void
  budget_(int *ipara,int *ID,int *nID,int *sz,int *ni,int *nj,int *nk,int *vc,
          SKL_REAL *time,SKL_REAL *dx,SKL_REAL *dy,SKL_REAL *dz,
          SKL_REAL *dt,SKL_REAL *wth,
          SKL_REAL *sg,SKL_REAL *sgn,SKL_REAL *uvw,SKL_REAL *uvwn,
          SKL_REAL *phi,SKL_REAL *phin,SKL_REAL *rlog,SKL_REAL *grv);

  void
  solxg_(int *vc,int *ni,int *nj,int *nk,SKL_REAL *dt,
         SKL_REAL *dx,SKL_REAL *dy,SKL_REAL *dz,SKL_REAL *wl,
         SKL_REAL *uvwn,SKL_REAL *xg,SKL_REAL *yg,SKL_REAL *zg,
         SKL_REAL *xgn,SKL_REAL *ygn,SKL_REAL *zgn,
         SKL_REAL *ug,SKL_REAL *vg,SKL_REAL *wg,
         int *ng,int *nid,int *id);










  void
  load_restart_uvw_(SKL_REAL* outwv, SKL_REAL* uvwk,
                     int*vc,int* ni,int* nj,int* nk);

  void
  load_restart_p_(SKL_REAL* outwv,SKL_REAL* p, SKL_REAL* phi,SKL_REAL* phio,
                  int*vc,int* ni,int* nj,int* nk);

  void
  load_restart_sgbl_(SKL_REAL* outwv,SKL_REAL* sbk,
                     int*vc,int* ni,int* nj,int* nk,int* flag);

  void
  calmises_(SKL_REAL *outw, SKL_REAL *sg, int *ni, int *nj, int *nk, int *vc);

  void
  cal_vg_(int *flag, int *ni, int *nj, int *nk, int *vc,
          SKL_REAL *dx, SKL_REAL *dy, SKL_REAL *dz,
          SKL_REAL *uvw, SKL_REAL *outw);

  void
  restart_uvw_(SKL_REAL* outwv, SKL_REAL* uvwk,
               int* vc,int* ni,int* nj,int* nk);

  void
  restart_p_(SKL_REAL* outwv,SKL_REAL* p, SKL_REAL* phi,SKL_REAL* phio,
             int* vc,int* ni,int* nj,int* nk);

  void
  restart_sgbl_(SKL_REAL* outwv,SKL_REAL* sbk,
                int* vc,int* ni,int* nj,int* nk,int* flag);

  void
  mkuvp_(int* vc,int* ni,int* nj,int* nk,int* nstep,
         SKL_REAL* dx,SKL_REAL* dy, SKL_REAL* dz,
         SKL_REAL* p, SKL_REAL* phi,SKL_REAL* uvw,
         SKL_REAL* REAL_MIN);

  void
  mkpost_(int* vc,int* ni,int* nj,int* nk,int* n,
          SKL_REAL* time,SKL_REAL* dx, SKL_REAL* dy,SKL_REAL* dz,
          SKL_REAL* p,   SKL_REAL* phi, SKL_REAL* uvw,SKL_REAL* sg,
          SKL_REAL* x4,  SKL_REAL* y4, SKL_REAL* z4,SKL_REAL* f4,
          SKL_REAL* p4,  SKL_REAL* uvw4);

  void
  solbl_(int* ni,int* nj,int* nk,int* vc,int* ipara,int* nID,
         SKL_REAL* uvw,SKL_REAL* uvwo,SKL_REAL* bl,SKL_REAL* blo,
         SKL_REAL* bln,SKL_REAL* phin,double* ftime,
         SKL_REAL* dt,SKL_REAL* dxinv,SKL_REAL* dyinv,
         SKL_REAL* dzinv,SKL_REAL *REAL_MIN);
}

#endif // _SKL_FORTRAN_FUNC_SPH3D_H_

