/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2008
 *
 */

#include "SklSolverSPH3D.h"

SklSolverSPH3D::SklSolverSPH3D() {
/* USER WRITE
   Please place initialize member variable here.
*/
  init();
}

SklSolverSPH3D::SklSolverSPH3D(int sType) {
/* USER WRITE
   Please place initialize member variable here.
*/
  init();
}

SklSolverSPH3D::~SklSolverSPH3D() {
/* USER WRITE
   Please place destory member variable here.
*/

}

void SklSolverSPH3D::init()
{
  int i;

  if( sizeof(SKL_REAL)==sizeof(float) ){
    REAL_MIN = FLT_MIN;
    REAL_MAX = FLT_MAX;
  } else {
    REAL_MIN = DBL_MIN;
    REAL_MAX = DBL_MAX;
  }
//  REAL_MIN = 1.0e-60;
//  REAL_MAX = 1.0e+60;

  imkuvp = 0;
  icherr = 1;
  histInterval = monInterval = 0;
  fpHist = NULL;

  calcStep = 0;
  TotalLoopTime = 0.0;
  for(i=0;i<10;i++) ftime[i] = 0.0;
  for(i=0;i<50;i++){
    rlog[i] = 0.0;
    ilog[i] = 0;
  }

  time = 0.0;

  ipara = -1;
  ID = 0;
  procGrp = 0;
  for(i=0;i<6;i++ ) nID[i] = -1;

  vc = 3;
  ni = nj = nk = 0;
  dx = dy = dz = 0.0;
  xl = yl = zl = 0.0;
  for(i=0;i<3;i++){
    sz[i] = 0;
    pch[i] = org[i] = wth[i] = 0.0;
  }

  for(i=0;i<8;i++){
    idx_si[i] = idx_sj[i] = idx_sk[i] = 1;
  }
  idx_si[1] = 2;
  idx_sj[1] = 2;
  idx_sk[1] = 2;
  idx_si[2] = 2;
  idx_sj[3] = 2;
  idx_sk[3] = 2;
  idx_si[4] = 2;
  idx_sk[4] = 2;
  idx_sj[5] = 2;
  idx_sk[6] = 2;
  idx_si[7] = 2;
  idx_sj[7] = 2;

  fixedDT = 0.0;
  isor = -1;
  itersor = 1000;
  sorbeta = 1.5;
  soreps = 1.0e-6;
  itersort = 0;

  pi = atan(1.0)*4.0;
  rnu00 = 1.0;
  gmd00 = 50.0;
  cfl = 0.25;
  grv = 1.0*0.5;
  grvuvw[0] = grvuvw[1] = grvuvw[2] = 0.0;

  imax = 4;

  dc_uvw = dc_uvwn = dc_uvwo = dc_outwv = dc_gravity = NULL;
  dc_p = dc_div = dc_phi = dc_phin = dc_phio = dc_outw = NULL;
  dc_pk = dc_advsx = dc_advsy = dc_advsz = NULL;
  dc_sg = dc_sgn = dc_sgo = dc_bl = dc_bln = dc_blo = NULL;

  uvw = uvwn = uvwo = outwv = gravity = NULL;
  p = div = phi = phin = phio = outw = NULL;
  pk = advsx = advsy = advsz = NULL;
  sg = sgn = sgo = bl = bln = blo = NULL;

  nw = 1;
  work = NULL;
  p1 = p2 = p3 = p4 = p5 = p6 = 0;

  buffsz[0] = buffsz[1] = buffsz[2] = 1;
  sendib = sendjb = sendkb = NULL;
  recvib = recvjb = recvkb = NULL;

  vc_out = 1;
  outVel = outPres = outPhi = outMis = NULL;
  outVG = outRes = NULL;

  pt = NULL;

  m_FOtime = 0.0;
}

