/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2008
 *
 */

#include "SklSolverSPH3D.h"

bool
SklSolverSPH3D::SklSolverPost() {
/* USER WRITE
   Please write solver post code.
*/
  int i;
  double ftimemax[10];
  double sendbuf[10],recvbuf[10];

  for( i=0;i<10;i++) ftimemax[i]=0.0;

  for( i=0;i<10;i++){
    sendbuf[i]=ftime[i];
    recvbuf[i]=ftime[i];
  }
  sendbuf[9] = m_FOtime;
  recvbuf[9] = m_FOtime;

  ParaMngr->Allreduce(sendbuf,recvbuf,10
                        ,SKL_ARRAY_DTYPE_DOUBLE,SKL_MAX,procGrp);

  for( i=0;i<10;i++){
    ftimemax[i]=recvbuf[i];
  }

  PrintPost(ftimemax, ftime );

#if 1
  char ft[100];
  sprintf( ft, "time/time_%04d.log", ID );
  FILE *fp = fopen( ft, "wt" );
  if( fp ){
    PrintPost( fp, ftimemax, ftime );
    fclose(fp);
  }
#endif

  return true;
}

