      subroutine bc(ipara,nID,ID,ni,nj,nk,vc,nstep,uvwk,ftime)
c
      implicit none
      include 'param.h'
      include 'sklparaf.h'

cc subroutine arguments
      integer ipara,nID(6),ID
      integer ni,nk,nj,vc
      integer nstep
      real uvwk(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real*8 ftime(10)

cc local variables
      integer ierr
      integer i,j,k
      real uw2
      real*8 frt_gettime
      real*8 frt_spantime
      real*8 tim
c
c<j (wall)
c
      if( nID(Y_MINUS).lt.0 ) then
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(uvwk)
        do k=1,nk
        do j=1,1
        do i=1,ni
        uvwk(1,i,1 -j,k)=-uvwk(1,i,     j,k)
        uvwk(3,i,1 -j,k)=-uvwk(3,i,     j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,k)
!$OMP$ SHARED(uvwk)
        do k=1,nk
        do i=1,ni
        uvwk(2,i, 0,k)=0.0d0
        enddo
        enddo
!$OMP END PARALLEL DO
      endif

      if( nID(Y_PLUS).lt.0 ) then
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(uvwk)
        do k=1,nk
        do j=1,1
        do i=1,ni
        uvwk(1,i,nj+j,k)=-uvwk(1,i,nj+1-j,k)
        uvwk(3,i,nj+j,k)=-uvwk(3,i,nj+1-j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,k)
!$OMP$ SHARED(vk)
        do k=1,nk
        do i=1,ni
        uvwk(2,i,nj,k)=0.0d0
        enddo
        enddo
!$OMP END PARALLEL DO
      endif

c
c<i (periodic)
c
      if( ipara.eq.1 ) then
        tim=frt_gettime()
        call SklCommPeriodicBndCell(uvwk,X_DIR,PLUS2MINUS,vc,ierr) !xmunus
        call SklCommPeriodicBndCell(uvwk,X_DIR,MINUS2PLUS,vc,ierr) !xplus
        ftime(7)=ftime(7)+frt_spantime(tim)
      else
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(uvwk)
        do k=1,nk
        do j=0,nj+1
        do i=1,1
        uvwk(1,ni+i,j,k)=uvwk(1,     i,j,k)
        uvwk(1,1 -i,j,k)=uvwk(1,ni+1-i,j,k)
        uvwk(3,ni+i,j,k)=uvwk(3,     i,j,k)
        uvwk(3,1 -i,j,k)=uvwk(3,ni+1-i,j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(uvwk)
        do k=1,nk
        do j=0,nj
        do i=1,1
        uvwk(2,ni+i,j,k)=uvwk(2,     i,j,k)
        uvwk(2,1 -i,j,k)=uvwk(2,ni+1-i,j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO
      endif

c
c<k (periodic)
c
      if( ipara.eq.1 ) then
        tim=frt_gettime()
        call SklCommPeriodicBndCell(uvwk,Z_DIR,PLUS2MINUS,vc,ierr) !zmunus
        call SklCommPeriodicBndCell(uvwk,Z_DIR,MINUS2PLUS,vc,ierr) !zplus
        ftime(7)=ftime(7)+frt_spantime(tim)
      else
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(uvwk)
        do k=1,1
        do j=0,nj+1
        do i=0,ni+1
        uvwk(1,i,j,nk+k)=uvwk(1,i,j,     k)
        uvwk(3,i,j,nk+k)=uvwk(3,i,j,     k)
        uvwk(1,i,j,1 -k)=uvwk(1,i,j,nk+1-k)
        uvwk(3,i,j,1 -k)=uvwk(3,i,j,nk+1-k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(vk)
        do k=1,1
        do j=0,nj
        do i=0,ni+1
        uvwk(2,i,j,nk+k)=uvwk(2,i,j,     k)
        uvwk(2,i,j,1 -k)=uvwk(2,i,j,nk+1-k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO
      endif

ccc
      return
      end

c -------------------------------------------------------------

