      subroutine bcsg(ipara,nID,ID,ni,nj,nk,vc,dx,dy,dz,rnu00,sgk,uvwk
     1                ,ftime)
c
      implicit none
      include 'sklparaf.h'
      include 'param.h'

cc subroutine arguments
      integer ipara,nID(6),ID
      integer ni,nj,nk,vc
      real dx,dy,dz
      real rnu00
      real  sgk(6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvwk(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real*8 ftime(10)

cc local variables
      integer ierr 
      integer i,j,k
      real dxinv,dyinv,dzinv
      real dxr2inv,dyr2inv,dzr2inv
      real*8 frt_gettime
      real*8 frt_spantime
      real*8 tim

ccc
      dxinv=1.0d0/dx
      dyinv=1.0d0/dy
      dzinv=1.0d0/dz
ccc
      dxr2inv=dxinv*rnu00*2.0d0
      dyr2inv=dyinv*rnu00*2.0d0
      dzr2inv=dzinv*rnu00*2.0d0

c
c<j (wall)
c
      if( nID(Y_MINUS).lt.0) then  !Yminus
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(sgk,rnu00)
!$OMP$ SHARED(uvwk)
!$OMP$ SHARED(dxinv,dyinv)
        do k=1,nk
        do i=1,ni

        do j=0,0,-1
        sgk(4, i  ,j  ,k)=rnu00*(
     1    (uvwk(1,i  ,j+1,k)-uvwk(1,i,j,k))*dyinv
     2   +(uvwk(2,i+1,j  ,k)-uvwk(2,i,j,k))*dxinv)
        enddo

        enddo
        enddo
!$OMP END PARALLEL DO
      endif

      if( nID(Y_PLUS).lt.0 ) then
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(sgk,rnu00)
!$OMP$ SHARED(uvwk)
!$OMP$ SHARED(dxinv,dyinv)
        do k=1,nk
        do i=1,ni

        do j=nj,nj
        sgk(4,i  ,j  ,k)=rnu00*(
     1    (uvwk(1,i  ,j+1,k)-uvwk(1,i,j,k))*dyinv
     2   +(uvwk(2,i+1,j  ,k)-uvwk(2,i,j,k))*dxinv)
        enddo

        enddo
        enddo
!$OMP END PARALLEL DO
      endif

      if( nID(Y_MINUS).lt.0) then  !Yminus
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(sgk,rnu00)
!$OMP$ SHARED(vk,wk)
!$OMP$ SHARED(dyinv,dzinv)
        do k=1,nk
        do i=1,ni

        do j=0,0,-1
        sgk(6,i,j  ,k  )=rnu00*(
     1    (uvwk(2,i,j  ,k+1)-uvwk(2,i,j,k))*dzinv
     2   +(uvwk(3,i,j+1,k  )-uvwk(3,i,j,k))*dyinv)
        enddo

        enddo
        enddo
!$OMP END PARALLEL DO
      endif

      if( nID(Y_PLUS).lt.0) then  !Yminus
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(sgk,rnu00)
!$OMP$ SHARED(vk,wk)
!$OMP$ SHARED(dyinv,dzinv)
        do k=1,nk
        do i=1,ni

        do j=nj,nj
        sgk(6,i,j  ,k  )=rnu00*(
     1    (uvwk(2,i,j  ,k+1)-uvwk(2,i,j,k))*dzinv
     2   +(uvwk(3,i,j+1,k  )-uvwk(3,i,j,k))*dyinv)
        enddo

        enddo
        enddo
!$OMP END PARALLEL DO
      endif

c
c<i (periodic)
c
      if( ipara.eq.1 ) then
        tim=frt_gettime()
        call SklCommPeriodicBndCell(sgk,X_DIR,MINUS2PLUS,vc,ierr) !Xplus
        call SklCommPeriodicBndCell(sgk,X_DIR,PLUS2MINUS,vc,ierr) !Xminus
        ftime(8)=ftime(8)+frt_spantime(tim)
      else
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(sgk)
        do k=1,nk
        do j=1,nj
        do i=1,1
        sgk(1,ni+i,j,k)=sgk(1,     i,j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(sgk)
        do k=1,nk
        do j=0,nj
        do i=1,1
        sgk(4,1 -i,j,k)=sgk(4,ni+1-i,j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(sgxzk)
        do k=1,nk
        do j=1,nj
        do i=1,1
        sgk(5,1 -i,j,k)=sgk(5,ni+1-i,j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO
      endif

c
c<k (periodic)
c
      if( ipara.eq.1 ) then 
        tim=frt_gettime()
        call SklCommPeriodicBndCell(sgk,Z_DIR,MINUS2PLUS,vc,ierr) !Zplus
        call SklCommPeriodicBndCell(sgk,Z_DIR,PLUS2MINUS,vc,ierr) !Zminus
        ftime(8)=ftime(8)+frt_spantime(tim)
      else
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(sgk)
        do k=1,1
        do j=1,nj
        do i=1,ni
        sgk(3,i,j,nk+k)=sgk(3,i,j,     k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(sgk)
        do k=1,1
        do j=1,nj
        do i=0,ni
        sgk(5,i,j,1 -k)=sgk(5,i,j,nk+1-k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(sgk)
        do k=1,1
        do j=0,nj
        do i=1,ni
        sgk(6,i,j,1 -k)=sgk(6,i,j,nk+1-k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO
      endif

ccc
      return
      end

c -------------------------------------------------------------

