      subroutine budget(ipara,ID,nID,vsall,ni,nj,nk,vc,
     1                  time,dx,dy,dz,dt,wl,
     2                  sg,sgn,uvw,uvwn,phi,phin,rlog,grv)
c
      implicit none
      include 'sklparaf.h'
      include 'param.h'

cc subroutine arguments
      integer ipara,ID,nID(6)
      integer vsall(3)
      integer vc
      integer ni,nj,nk
      real wl(3)
      real time,dt
      real dx,dy,dz
      real uvw (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvwn(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phi   (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phin  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real sg  (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real sgn (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real rlog(43)
      real grv

cc local variables 
      integer ierr
      integer i,j,k
      real dxinv,dyinv,dzinv
      real umean,ums,vmean,vms,wmean,wms
      real den,den1,den2,den3,den4,flg
      real dis_s_xx,dis_s_yy,dis_s_zz,dis_s_xy,dis_s_xz,dis_s_yz
      real dis_f_xx,dis_f_yy,dis_f_zz,dis_f_xy,dis_f_xz,dis_f_yz
      real d12,d21,d13,d31,d23,d32
      real d11_1,d22_1,d33_1,d12_1,d21_1,d13_1,d31_1,d23_1,d32_1
      real s11,s22,s33,s12,s13,s23
      real phis,phif
      real diss_s,diss_f
      real der_kin1,der_kin2,der_kin3,der_kin
      real dtinv,prod
      real duudt,dvvdt,dwwdt
      real tauw1,tauw2
      real uw1,uw2
      real*8 sendbuf(16),recvbuf(16)
      real f1,f2
c
      dxinv=1.0d0/dx
      dyinv=1.0d0/dy
      dzinv=1.0d0/dz
ccc
ccc<check mean velocity
ccc
      umean =0.0d0
      ums   =0.0d0
      den1=0.0d0
      flg=dx*dy*dz
      do k=1,nk
      do j=1,nj
      do i=1,ni
c
      umean =umean + uvw(1,i,j,k)   *flg
      ums   =ums   + uvw(1,i,j,k)**2*flg
      den1  =den1  +                 flg
c
      enddo
      enddo
      enddo
c
      vmean =0.0d0
      vms   =0.0d0
      den2=0.0d0
      do k=1,nk
      do j=0,nj
      flg=dx*dy*dz
      if(j.eq.0.or.j.eq.nj)flg=flg*0.5d0
      do i=1,ni
c
      vmean =vmean + uvw(2,i,j,k)   *flg
      vms   =vms   + uvw(2,i,j,k)**2*flg
      den2  =den2  +                 flg
c
      enddo
      enddo
      enddo
c
      wmean =0.0d0
      wms   =0.0d0

      den3=0.0d0
      flg=dx*dy*dz
      do k=1,nk
      do j=1,nj
      do i=1,ni
c
      wmean =wmean + uvw(3,i,j,k)   *flg
      wms   =wms   + uvw(3,i,j,k)**2*flg
      den3  =den3  +                 flg
c
      enddo
      enddo
      enddo
cccc
      do i=1,16
      sendbuf(i)=0.0
      recvbuf(i)=0.0
      enddo


      sendbuf(1) = umean
      recvbuf(1) = umean
      sendbuf(2) = ums
      recvbuf(2) = ums
      sendbuf(3) = den1
      recvbuf(3) = den1

      sendbuf(4) = vmean
      recvbuf(4) = vmean
      sendbuf(5) = vms
      recvbuf(5) = vms
      sendbuf(6) = den2
      recvbuf(6) = den2

      sendbuf(7) = wmean
      recvbuf(7) = wmean
      sendbuf(8) = wms
      recvbuf(8) = wms
      sendbuf(9) = den3
      recvbuf(9) = den3

      call SklAllreduce(sendbuf,recvbuf,9,SKL_REAL8,SKL_SUM,0,ierr)

      umean = recvbuf(1)
      ums   = recvbuf(2)
      den1  = recvbuf(3)

      vmean = recvbuf(4)
      vms   = recvbuf(5)
      den2  = recvbuf(6)

      wmean = recvbuf(7)
      wms   = recvbuf(8)
      den3  = recvbuf(9)
cccc
      umean=umean/den1
      ums  =ums  /den1

      vmean=vmean/den2
      vms  =vms  /den2

      wmean=wmean/den3
      wms  =wms  /den3
c
c      if( ID == 0 ) then
c      write(*,'("UMEAN ",20e20.10)')
c     1  time
c     2 ,umean
c     3 ,ums
c     4 ,vmean
c     5 ,vms
c     6 ,wmean
c     7 ,wms
c      endif

      rlog(23)=time
      rlog(24)=umean
      rlog(25)=ums
      rlog(26)=vmean
      rlog(27)=vms
      rlog(28)=wmean
      rlog(29)=wms

ccc
ccc<calculate dissipation rate
ccc
cc
cc<current component
cc
      dis_s_xx=0.0d0
      dis_s_yy=0.0d0
      dis_s_zz=0.0d0
      dis_s_xy=0.0d0
      dis_s_xz=0.0d0
      dis_s_yz=0.0d0
      dis_f_xx=0.0d0
      dis_f_yy=0.0d0
      dis_f_zz=0.0d0
      dis_f_xy=0.0d0
      dis_f_xz=0.0d0
      dis_f_yz=0.0d0
c
      den1=0.0d0
      den2=0.0d0
      den3=0.0d0
      den4=0.0d0
c
      flg=dx*dy*dz
      do k=1,nk
      do j=1,nj
      do i=1,ni
c     
      d11_1=uvw(1,i,j,k)-uvw(1,i-1,j  ,k  )
      d22_1=uvw(2,i,j,k)-uvw(2,i  ,j-1,k  )
      d33_1=uvw(3,i,j,k)-uvw(3,i  ,j  ,k-1)
c
      s11=d11_1*dxinv
      s22=d22_1*dyinv
      s33=d33_1*dzinv
c

      phis=phi(i,j,k)
      phif=1.0d0-phis
c
      dis_s_xx=dis_s_xx+sg(1,i,j,k)*s11*phis*flg
      dis_s_yy=dis_s_yy+sg(2,i,j,k)*s22*phis*flg
      dis_s_zz=dis_s_zz+sg(3,i,j,k)*s33*phis*flg
      dis_f_xx=dis_f_xx+sg(1,i,j,k)*s11*phif*flg
      dis_f_yy=dis_f_yy+sg(2,i,j,k)*s22*phif*flg
      dis_f_zz=dis_f_zz+sg(3,i,j,k)*s33*phif*flg
c
      d11_1=uvwn(1,i,j,k)-uvwn(1,i-1,j  ,k  )
      d22_1=uvwn(2,i,j,k)-uvwn(2,i  ,j-1,k  )
      d33_1=uvwn(3,i,j,k)-uvwn(3,i  ,j  ,k-1)
c
      s11=d11_1*dxinv
      s22=d22_1*dyinv
      s33=d33_1*dzinv
c
      phis=phin(i,j,k)
      phif=1.0d0-phis
c
      dis_s_xx=dis_s_xx+sgn(1,i,j,k)*s11*phis*flg
      dis_s_yy=dis_s_yy+sgn(2,i,j,k)*s22*phis*flg
      dis_s_zz=dis_s_zz+sgn(3,i,j,k)*s33*phis*flg
      dis_f_xx=dis_f_xx+sgn(1,i,j,k)*s11*phif*flg
      dis_f_yy=dis_f_yy+sgn(2,i,j,k)*s22*phif*flg
      dis_f_zz=dis_f_zz+sgn(3,i,j,k)*s33*phif*flg
c
      den1=den1+flg
c
      enddo
      enddo
      enddo
c
      do k=1,nk
      do j=0,nj
      flg=dx*dy*dz
      if(j.eq.0.or.j.eq.nj)flg=flg*0.5d0
      do i=1,ni
c
      d12_1=uvw(1,i  ,j+1,k)-uvw(1,i,j,k)
      d21_1=uvw(2,i+1,j  ,k)-uvw(2,i,j,k)
c
      d12=d12_1*dyinv
      d21=d21_1*dxinv
c
      s12=(d12+d21)*0.5d0
c
      phis=(phi(i,j  ,k)+phi(i+1,j  ,k)
     1     +phi(i,j+1,k)+phi(i+1,j+1,k))*0.25d0
      phif=1.0d0-phis
c
      dis_s_xy=dis_s_xy+sg(4,i,j,k)*s12*phis*flg
      dis_f_xy=dis_f_xy+sg(4,i,j,k)*s12*phif*flg
c
      d12_1=uvwn(1,i  ,j+1,k)-uvwn(1,i,j,k)
      d21_1=uvwn(2,i+1,j  ,k)-uvwn(2,i,j,k)
c
      d12=d12_1*dyinv
      d21=d21_1*dxinv
c
      s12=(d12+d21)*0.5d0
c
      phis=(phin(i,j  ,k)+phin(i+1,j  ,k)
     1     +phin(i,j+1,k)+phin(i+1,j+1,k))*0.25d0
      phif=1.0d0-phis
c
      dis_s_xy=dis_s_xy+sgn(4,i,j,k)*s12*phis*flg
      dis_f_xy=dis_f_xy+sgn(4,i,j,k)*s12*phif*flg
c
      den2=den2+flg
c
      enddo
      enddo
      enddo
c
      flg=dx*dy*dz
      do k=1,nk
      do j=1,nj
      do i=1,ni
c
      d13_1=uvw(1,i  ,j,k+1)-uvw(1,i,j,k)
      d31_1=uvw(3,i+1,j,k  )-uvw(3,i,j,k)
c
      d13=d13_1*dzinv
      d31=d31_1*dxinv
c
      s13=(d13+d31)*0.5d0
c
      phis=(phi(i,j,k  )+phi(i+1,j,k  )
     1     +phi(i,j,k+1)+phi(i+1,j,k+1))*0.25d0
      phif=1.0d0-phis
c
      dis_s_xz=dis_s_xz+sg(5,i,j,k)*s13*phis*flg
      dis_f_xz=dis_f_xz+sg(5,i,j,k)*s13*phif*flg
c
      d13_1=uvwn(1,i  ,j,k+1)-uvwn(1,i,j,k)
      d31_1=uvwn(3,i+1,j,k  )-uvwn(3,i,j,k)
c
      d13=d13_1*dzinv
      d31=d31_1*dxinv
c
      s13=(d13+d31)*0.5d0
c
      phis=(phin(i,j,k  )+phin(i+1,j,k  )
     1     +phin(i,j,k+1)+phin(i+1,j,k+1))*0.25d0
      phif=1.0d0-phis
c
      dis_s_xz=dis_s_xz+sgn(5,i,j,k)*s13*phis*flg
      dis_f_xz=dis_f_xz+sgn(5,i,j,k)*s13*phif*flg
c
      den3=den3+flg
c
      enddo
      enddo
      enddo
c
      flg=dx*dy*dz
      do k=1,nk
      do j=1,nj
      do i=1,ni
c
      d23_1=uvw(2,i,j  ,k+1)-uvw(2,i,j,k)
      d32_1=uvw(3,i,j+1,k  )-uvw(3,i,j,k)
c
      d23=d23_1*dzinv
      d32=d32_1*dyinv
c
      s23=(d23+d32)*0.5d0
c
      phis=(phi(i,j,k  )+phi(i,j+1,k  )
     1     +phi(i,j,k+1)+phi(i,j+1,k+1))*0.25d0
      phif=1.0d0-phis
c
      dis_s_yz=dis_s_yz+sg(6,i,j,k)*s23*phis*flg
      dis_f_yz=dis_f_yz+sg(6,i,j,k)*s23*phif*flg
c
      d23_1=uvwn(2,i,j  ,k+1)-uvwn(2,i,j,k)
      d32_1=uvwn(3,i,j+1,k  )-uvwn(3,i,j,k)
c
      d23=d23_1*dzinv
      d32=d32_1*dyinv
c
      s23=(d23+d32)*0.5d0
c
      phis=(phin(i,j,k  )+phin(i,j+1,k  )
     1     +phin(i,j,k+1)+phin(i,j+1,k+1))*0.25d0
      phif=1.0d0-phis
c
      dis_s_yz=dis_s_yz+sgn(6,i,j,k)*s23*phis*flg
      dis_f_yz=dis_f_yz+sgn(6,i,j,k)*s23*phif*flg
c
      den4=den4+flg
c
      enddo
      enddo
      enddo
c
      do i=1,16
      sendbuf(i)=0.0
      recvbuf(i)=0.0
      enddo

      sendbuf(1)=dis_s_xx
      recvbuf(1)=dis_s_xx
      sendbuf(2)=dis_s_yy
      recvbuf(2)=dis_s_yy
      sendbuf(3)=dis_s_zz
      recvbuf(3)=dis_s_zz
      sendbuf(4)=dis_s_xy
      recvbuf(4)=dis_s_xy
      sendbuf(5)=dis_s_xz
      recvbuf(5)=dis_s_xz
      sendbuf(6)=dis_s_yz
      recvbuf(6)=dis_s_yz
c
      sendbuf(7)=dis_f_xx
      recvbuf(7)=dis_f_xx
      sendbuf(8)=dis_f_yy
      recvbuf(8)=dis_f_yy
      sendbuf(9)=dis_f_zz
      recvbuf(9)=dis_f_zz
      sendbuf(10)=dis_f_xy
      recvbuf(10)=dis_f_xy
      sendbuf(11)=dis_f_xz
      recvbuf(11)=dis_f_xz
      sendbuf(12)=dis_f_yz
      recvbuf(12)=dis_s_yz
c
      sendbuf(13)=den1
      recvbuf(13)=den1
      sendbuf(14)=den2
      recvbuf(14)=den2
      sendbuf(15)=den3
      recvbuf(15)=den3
      sendbuf(16)=den4
      recvbuf(16)=den4

      call SklAllreduce(sendbuf,recvbuf,16,SKL_REAL8,SKL_SUM,0,ierr) 

      dis_s_xx=recvbuf(1)
      dis_s_yy=recvbuf(2)
      dis_s_zz=recvbuf(3)
      dis_s_xy=recvbuf(4)
      dis_s_xz=recvbuf(5)
      dis_s_yz=recvbuf(6)
c
      dis_f_xx=recvbuf(7)
      dis_f_yy=recvbuf(8)
      dis_f_zz=recvbuf(9)
      dis_f_xy=recvbuf(10)
      dis_f_xz=recvbuf(11)
      dis_f_yz=recvbuf(12)
c
      den1    =recvbuf(13)
      den2    =recvbuf(14)
      den3    =recvbuf(15)
      den4    =recvbuf(16)

      dis_s_xx=dis_s_xx/den1*0.5d0
      dis_s_yy=dis_s_yy/den1*0.5d0
      dis_s_zz=dis_s_zz/den1*0.5d0
      dis_s_xy=dis_s_xy/den2*0.5d0
      dis_s_xz=dis_s_xz/den3*0.5d0
      dis_s_yz=dis_s_yz/den4*0.5d0

      dis_f_xx=dis_f_xx/den1*0.5d0
      dis_f_yy=dis_f_yy/den1*0.5d0
      dis_f_zz=dis_f_zz/den1*0.5d0
      dis_f_xy=dis_f_xy/den2*0.5d0
      dis_f_xz=dis_f_xz/den3*0.5d0
      dis_f_yz=dis_f_yz/den4*0.5d0

        diss_s=
     1   dis_s_xx
     2 + dis_s_yy
     3 + dis_s_zz
     4 + dis_s_xy*2.0d0
     5 + dis_s_xz*2.0d0
     6 + dis_s_yz*2.0d0

        diss_f=
     1   dis_f_xx
     2 + dis_f_yy
     3 + dis_f_zz
     4 + dis_f_xy*2.0d0
     5 + dis_f_xz*2.0d0
     6 + dis_f_yz*2.0d0

ccc
ccc<time derivative of kinetic energy 
ccc
      der_kin1=0.0d0
      der_kin2=0.0d0
      der_kin3=0.0d0
      den1=0.0d0
      den2=0.0d0
      den3=0.0d0
      dtinv=1.0d0/dt
c
      flg=dx*dy*dz
      do k=1,nk
      do j=1,nj
      do i=1,ni
      duudt= uvwn(1,i,j,k)**2-uvw(1,i,j,k)**2
      der_kin1=der_kin1+duudt*dtinv*flg
      den1=den1+flg
      enddo
      enddo
      enddo
c
      do k=1,nk
      do j=0,nj
      flg=dx*dy*dz
      if(j.eq.0.or.j.eq.nj)flg=flg*0.5d0
      do i=1,ni
      dvvdt= uvwn(2,i,j,k)**2-uvw(2,i,j,k)**2
      der_kin2=der_kin2+dvvdt*dtinv*flg
      den2=den2+flg
      enddo
      enddo
      enddo
c
      flg=dx*dy*dz
      do k=1,nk
      do j=1,nj
      do i=1,ni
      dwwdt= uvwn(3,i,j,k)**2-uvw(3,i,j,k)**2
      der_kin3=der_kin3+dwwdt*dtinv*flg
      den3=den3+flg
      enddo
      enddo
      enddo
c
      do i=1,16
      sendbuf(i)=0.0
      recvbuf(i)=0.0
      enddo

      sendbuf(1)=der_kin1
      recvbuf(1)=der_kin1
      sendbuf(2)=der_kin2
      recvbuf(2)=der_kin2
      sendbuf(3)=der_kin3
      recvbuf(3)=der_kin3

      sendbuf(4)=den1
      recvbuf(4)=den1
      sendbuf(5)=den2
      recvbuf(5)=den2
      sendbuf(6)=den3
      recvbuf(6)=den3

      call SklAllreduce(sendbuf,recvbuf,6,SKL_REAL8,SKL_SUM,0,ierr)

      der_kin1=recvbuf(1)
      der_kin2=recvbuf(2)
      der_kin3=recvbuf(3)
      den1    =recvbuf(4)
      den2    =recvbuf(5)
      den3    =recvbuf(6)


      der_kin1=der_kin1/den1
      der_kin2=der_kin2/den2
      der_kin3=der_kin3/den3
c
      der_kin=(der_kin1+der_kin2+der_kin3)*0.5d0
c
cc      prod=0.0d0
cc      flg=dx*dz
cc      den1=0.0d0
cc      f1=0.0
cc      f2=0.0
cc      if( nID(Y_MINUS).lt.0 ) then
cc        f1=1.0
cc      else
cc        f1=0.0
cc      endif
cc      if( nID(Y_PLUS ).lt.0 ) then
cc        f2=1.0
cc      else
cc        f2=0.0
cc      endif
cc
cc      do k=1,nk
cc      do i=1,ni
cc      prod=prod+(
cc     1  - sg(4,i, 0,k)*( uvw(1,i, 0,k)+ uvw(1,i,   1,k))
cc     1  -sgn(4,i, 0,k)*(uvwn(1,i, 0,k)+uvwn(1,i,   1,k))
cc     & )*flg*0.25d0*f1 
cc     1         +(
cc     1  + sg(4,i,nj,k)*( uvw(1,i,nj,k)+ uvw(1,i,nj+1,k))
cc     1  +sgn(4,i,nj,k)*(uvwn(1,i,nj,k)+uvwn(1,i,nj+1,k))
cc     & )*flg*0.25d0*f2
cc
cc      enddo
cc      enddo
cc      den1=vsall(1)*vsall(3)*dx*dz
cc
cc      do i=1,16
cc      sendbuf(i)=0.0
cc      recvbuf(i)=0.0
cc      enddo
cc
cc      sendbuf(1)=prod
cc      recvbuf(1)=prod
ccc      sendbuf(2)=den1
ccc      recvbuf(2)=den1
cc
cc      call SklAllreduce(sendbuf,recvbuf,1,SKL_REAL8,SKL_SUM,0,ierr)
cc
cc      prod=recvbuf(1)
ccc      den1=recvbuf(2)
cc
cc      prod=prod/den1/wl(2)

      prod=umean*grv

ccc
ccc<display budget of kinetic energy trasnport
ccc
c      if( ID==0 ) then
c      write(*,'("Budget_Kin ",20e20.10)')
c     1  time
c     2 ,-diss_s
c     3 ,-diss_f
c     4 ,-der_kin
c     5 , prod
c     6 ,-diss_s-diss_f-der_kin+prod
c      endif

      rlog(30)=time
      rlog(31)=-diss_s
      rlog(32)=-diss_f
      rlog(33)=-der_kin
      rlog(34)=prod
      rlog(35)=-diss_s-diss_f-der_kin+prod

      tauw1=0.0d0
      tauw2=0.0d0
      uw1  =0.0d0
      uw2  =0.0d0
      flg=dx*dz
      den1=0.0d0
      if( nID(Y_MINUS).lt.0 ) then
      do k=1,nk
      do i=1,ni
      tauw1=tauw1+(sg(4,i, 0,k)+sgn(4,i, 0,k))*0.5d0*flg
      uw1=uw1+(uvw(1,i, 0,k)+uvw(1,i,   1,k)
     +  +uvwn(1,i, 0,k)+uvwn(1,i,   1,k))*0.25d0*flg
      enddo
      enddo
      endif
      if( nID(Y_PLUS).lt.0 ) then
      do k=1,nk
      do i=1,ni
      tauw2=tauw2+(sg(4,i,nj,k)+sgn(4,i,nj,k))*0.5d0*flg
      uw2=uw2+(uvw(1,i,nj,k)+uvw(1,i,nj+1,k)
     +  +uvwn(1,i,nj,k)+uvwn(1,i,nj+1,k))*0.25d0*flg
      enddo
      enddo
      endif
      den1=vsall(1)*vsall(3)*dx*dz


      do i=1,16
      sendbuf(i)=0.0
      recvbuf(i)=0.0
      enddo

      sendbuf(1)=tauw1
      recvbuf(1)=tauw1
      sendbuf(2)=tauw2
      recvbuf(2)=tauw2
      sendbuf(3)=uw1
      recvbuf(3)=uw1
      sendbuf(4)=uw2
      recvbuf(4)=uw2
c      sendbuf(5)=den1
c      recvbuf(5)=den1

      call SklAllreduce(sendbuf,recvbuf,4,SKL_REAL8,SKL_SUM,0,ierr)

      tauw1=recvbuf(1)
      tauw2=recvbuf(2)
      uw1  =recvbuf(3)
      uw2  =recvbuf(4)
c      den1 =recvbuf(5)

      
      tauw1=tauw1/den1
      tauw2=tauw2/den1
      uw1  =uw1  /den1
      uw2  =uw2  /den1

c      if( ID==0 ) then
c      write(*,'("TAUW ",20e20.10)')
c     1  time
c     2 ,tauw1
c     3 ,tauw2
c     4 ,uw1
c     5 ,uw2
c      endif

      rlog(36)=time
      rlog(37)=tauw1
      rlog(38)=tauw2
      rlog(39)=uw1
      rlog(40)=uw2
c
      return
      end

