      subroutine caldt(ID,vc,ni,nj,nk,imon_t,nstep,
     1                 rnu00,gmd00,cfl,dt,time,dx,dy,dz,uvw,REAL_MAX,
     2                 rlog,ftime)
c
      implicit none
      include 'sklparaf.h'

cc subroutine arguments
      integer ID
      integer vc
      integer ni,nj,nk
      integer imon_t,nstep
      real REAL_MAX
      real rnu00,gmd00,cfl,dt,time
      real dx,dy,dz
      real uvw(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real rlog(43)
      real*8 ftime(10)

cc local variables 
      integer ierr
      integer i,j,k
      real dxinv,dyinv,dzinv
      real dx2,dy2,dz2
      real umax,cvis,dt1,dt2,dt3
      real*8 sendbuf1,recvbuf1,sendbuf2,recvbuf2
      real*8 frt_gettime
      real*8 frt_spantime
      real*8 tim
      real sqrt_gmd00

      dxinv=1.0d0/dx
      dyinv=1.0d0/dy
      dzinv=1.0d0/dz

      dx2 = dx**2
      dy2 = dy**2
      dz2 = dz**2

c      umax=-1.0d0
c      cvis=REAL_MAX
      umax=-1.0d-20
      cvis=1.0d+99
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(u,v,w,dxinv,dyinv,dzinv)
!$OMP$ REDUCTION(max:umax)
      do k=1,nk
      do j=1,nj
      do i=1,ni
      umax=max(umax,abs(uvw(1,i,j,k)*dxinv))
      umax=max(umax,abs(uvw(2,i,j,k)*dyinv))
      umax=max(umax,abs(uvw(3,i,j,k)*dzinv))
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO
c
      cvis=min(dx2/rnu00,cvis)
      cvis=min(dy2/rnu00,cvis)
      cvis=min(dz2/rnu00,cvis)
c
      sendbuf1 = umax
      recvbuf1 = umax
      sendbuf2 = cvis
      recvbuf2 = cvis

      tim=frt_gettime()
      call SklAllreduce(sendbuf1,recvbuf1,1,SKL_REAL8,SKL_MAX,0,ierr)
      call SklAllreduce(sendbuf2,recvbuf2,1,SKL_REAL8,SKL_MIN,0,ierr)
      ftime(1)=ftime(1)+frt_spantime(tim)

      umax = recvbuf1
      cvis = recvbuf2
c
      dt1=cfl/umax
      dt2=cfl*cvis*0.5d0

      umax=0.0d0
      sqrt_gmd00=sqrt(gmd00)
      umax=max(umax,abs(sqrt_gmd00*dxinv))
      umax=max(umax,abs(sqrt_gmd00*dyinv))
      umax=max(umax,abs(sqrt_gmd00*dzinv))

      dt3=cfl/umax
c
ccc      dt=min(dt1,dt2)
ccc      dt=min(dt1,dt3)
c
      dt=5.0d-4
      time=time+dt
c
c      if( ID == 0 ) then
      if(mod(nstep,imon_t).eq.0)then
c      write(*,'("dt_adv_vis ",20e20.10)')dt,dt1,dt2,time
c      endif
        rlog(1)=dt
        rlog(2)=dt1
        rlog(3)=dt2
        rlog(4)=time
        rlog(44)=dt3
      endif
c
      return
      end

c -------------------------------------------------------------

