c--------+---------+---------+---------+---------+---------+---------+-----
      subroutine commface(imax,jmax,kmax,vce,p,n_ID,
     1                    recvib,recvjb,recvkb,sendib,sendjb,sendkb,
     1                    buffsz,key,istart,jstart,kstart,ipg)
c--------------------------------------------------------------------------
      implicit none
      include 'sklparaf.h'
      include 'param.h'

      integer imax, jmax, kmax, vce
      integer istart,jstart,kstart
      real p
      dimension  p(1-vce:imax+vce,1-vce:jmax+vce,1-vce:kmax+vce)
      integer buffsz(3)
      real recvib,recvjb,recvkb,sendib,sendjb,sendkb
      dimension  recvib(buffsz(1),2),
     1           recvjb(buffsz(2),2),
     1           recvkb(buffsz(3),2),
     1           sendib(buffsz(1),2),
     1           sendjb(buffsz(2),2),
     1           sendkb(buffsz(3),2)

      integer n_ID(6)
      integer key(6,2)

      integer i, j, k
      integer ipg,isz,ierr

c initialize
      do i=1,6
        key(i,1) = -1   ! send ID
        key(i,2) = -1   ! recv ID
      enddo
c
cccccccccccccccccccccccccccc
c x-face
c   -x face send
      if( istart.eq.1 .and. n_ID(X_MINUS).ge.0 ) then
        isz = 1
        do k=kstart,kmax,2
        do j=jstart,jmax,2
          sendib(isz,1) = p(1, j, k)
          isz = isz + 1
        enddo
        enddo
        call SklImmediateSend(sendib(1,1),buffsz(1),SKL_REAL8,
     1                        n_ID(X_MINUS),ipg,key(1,1),ierr)       
      endif
c
c   +x face recv
      if( mod( imax-istart, 2).eq.1 .and. n_ID(X_PLUS).ge.0 ) then
        call SklImmediateRecv(recvib(1,1),buffsz(1),SKL_REAL8,
     1                        n_ID(X_PLUS),ipg,key(1,2),ierr)
      endif
c
c   +x face send
      if( mod(imax-istart,2).eq.0 .and. n_ID(X_PLUS).ge.0 ) then
        isz = 1
        do k=kstart,kmax,2
        do j=jstart,jmax,2
          sendib(isz,2) = p(imax, j, k)
          isz = isz + 1
        enddo
        enddo
        call SklImmediateSend(sendib(1,2),buffsz(1),SKL_REAL8,
     1                        n_ID(X_PLUS),ipg,key(2,1),ierr)       
      endif
c
c   -x face recv
      if( istart.ne.1 .and. n_ID(X_MINUS).ge.0 ) then
        call SklImmediateRecv(recvib(1,2),buffsz(1),SKL_REAL8,
     1                        n_ID(X_MINUS),ipg,key(2,2),ierr)
      endif
c
cccccccccccccccccccccccccccc
c y-face
c   -y face send
      if( jstart.eq.1 .and. n_ID(Y_MINUS).ge.0 ) then
        isz = 1
        do k=kstart,kmax,2
        do i=istart,imax,2
          sendjb(isz,1) = p(i, 1, k)
          isz = isz + 1
        enddo
        enddo
        call SklImmediateSend(sendjb(1,1),buffsz(2),SKL_REAL8,
     1                        n_ID(Y_MINUS),ipg,key(3,1),ierr)       
      endif
c
c   +y face recv
      if( mod( jmax-jstart, 2).eq.1 .and. n_ID(Y_PLUS).ge.0 ) then
        call SklImmediateRecv(recvjb(1,1),buffsz(2),SKL_REAL8,
     1                        n_ID(Y_PLUS),ipg,key(3,2),ierr)
      endif
c
c   +y face send
      if( mod(jmax-jstart,2).eq.0 .and. n_ID(Y_PLUS).ge.0 ) then
        isz = 1
        do k=kstart,kmax,2
        do i=istart,imax,2
          sendjb(isz,2) = p(i, jmax, k)
          isz = isz + 1
        enddo
        enddo
        call SklImmediateSend(sendjb(1,2),buffsz(2),SKL_REAL8,
     1                        n_ID(Y_PLUS),ipg,key(4,1),ierr)       
      endif
c
c   -y face recv
      if( jstart.ne.1 .and. n_ID(Y_MINUS).ge.0 ) then
        call SklImmediateRecv(recvjb(1,2),buffsz(2),SKL_REAL8,
     1                        n_ID(Y_MINUS),ipg,key(4,2),ierr)
      endif
c
cccccccccccccccccccccccccccc
c z-face
c   -z face send
      if( kstart.eq.1 .and. n_ID(Z_MINUS).ge.0 ) then
        isz = 1
        do j=jstart,jmax,2
        do i=istart,imax,2
          sendkb(isz,1) = p(i, j, 1)
          isz = isz + 1
        enddo
        enddo
        call SklImmediateSend(sendkb(1,1),buffsz(3),SKL_REAL8,
     1                        n_ID(Z_MINUS),ipg,key(5,1),ierr)       
      endif
c
c   +z face recv
      if( mod( kmax-kstart, 2).eq.1 .and. n_ID(Z_PLUS).ge.0 ) then
        call SklImmediateRecv(recvkb(1,1),buffsz(3),SKL_REAL8,
     1                        n_ID(Z_PLUS),ipg,key(5,2),ierr)
      endif
c
c   +z face send
      if( mod(kmax-kstart,2).eq.0 .and. n_ID(Z_PLUS).ge.0 ) then
        isz = 1
        do j=jstart,jmax,2
        do i=istart,imax,2
          sendkb(isz,2) = p(i, j, kmax)
          isz = isz + 1
        enddo
        enddo
        call SklImmediateSend(sendkb(1,2),buffsz(3),SKL_REAL8,
     1                        n_ID(Z_PLUS),ipg,key(6,1),ierr)       
      endif
c
c   -z face recv
      if( kstart.ne.1 .and. n_ID(Z_MINUS).ge.0 ) then
        call SklImmediateRecv(recvkb(1,2),buffsz(3),SKL_REAL8,
     1                        n_ID(Z_MINUS),ipg,key(6,2),ierr)
      endif
!
      return
      end

