      subroutine corun(vc,ni,nj,nk,dt,dx,dy,dz,p,uvwn)
c
      implicit none

cc subroutine arguments
      integer vc
      integer ni,nj,nk
      real dt
      real dx,dy,dz
      real p     (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvwn(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

cc local variables 
      integer i,j,k
      real dxinv,dyinv,dzinv
      real dtdxinv,dtdyinv,dtdzinv
      real dpx1,dpy1,dpz1
c
      dxinv = 1.d0/dx
      dyinv = 1.d0/dy
      dzinv = 1.d0/dz

      dtdxinv=dt*dxinv
      dtdyinv=dt*dyinv
      dtdzinv=dt*dzinv

cc
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ PRIVATE(dpx1)
!$OMP$ SHARED(p)
!$OMP$ SHARED(uvwn,dtdxinv)
      do k=1,nk
      do j=1,nj
      do i=1,ni
      dpx1=-p(i,j,k)+p(i+1,j  ,k  )
      uvwn(1,i,j,k)=uvwn(1,i,j,k)-dpx1*dtdxinv
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

      write(*,*) "p(1,1,1)",p(1,1,1)
      write(*,*) "p(2,1,1)",p(2,1,1)
      write(*,*) "uvwn(1,1,1,1)",uvwn(1,1,1,1)

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ PRIVATE(dpy1)
!$OMP$ SHARED(p)
!$OMP$ SHARED(uvwn,dtdyinv)
      do k=1,nk
      do j=1,nj
      do i=1,ni
      dpy1=-p(i,j,k)+p(i  ,j+1,k  )
      uvwn(2,i,j,k)=uvwn(2,i,j,k)-dpy1*dtdyinv
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ PRIVATE(dpz1)
!$OMP$ SHARED(p)
!$OMP$ SHARED(uvwn,dtdzinv)
      do k=1,nk
      do j=1,nj
      do i=1,ni
      dpz1=-p(i,j,k)+p(i  ,j  ,k+1)
      uvwn(3,i,j,k)=uvwn(3,i,j,k)-dpz1*dtdzinv
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO


cc
      return
      end

c -------------------------------------------------------------

