      subroutine init(ipara,nID,ID,ni,nj,nk,vc,
     1                rnu00,dx,dy,dz,wth,
     2                phi,phio,uvw,uvwo,p,sg,sgo,bl,blo,
     2                gravity,grvuvw,ftime)
c
      implicit none
      include 'sklparaf.h'

cc subroutine arguments
      integer ipara,nID(6),ID
      integer ni,nj,nk,vc
      real rnu00
      real dx,dy,dz,wth(3)
      real phi       (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phio      (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvw     (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvwo    (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real p         (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real sg      (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real sgo     (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real bl      (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real blo     (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real gravity (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

      real grvuvw(3);

      real*8 ftime(10)


cc local variables 
      integer idx,idy,idz,ierr
      integer i,j,k,ii,jj,kk
      integer nii,njj,nkk
      integer ifrg_yzmm1,ifrg_yzpm1,ifrg_yzmp1,ifrg_yzpp1
      integer ifrg_mmm,ifrg_pmm,ifrg_mpm,ifrg_ppm,ifrg_mmp
      integer ifrg_pmp,ifrg_mpp,ifrg_ppp,ifrg_mul,ifrg_sum
      real xm1,ym1,zm1
      real xp1,yp1,zp1
      real r2mm,r2pm,r2mp,r2pp
      real sqrt_in_yzmm1,sqrt_in_yzpm1,sqrt_in_yzmp1,sqrt_in_yzpp1
      real dxxii,dyyjj,dzzkk,dvol
      real x00,y00,z00,r200,sqrt_in_r00
      real phis_root
      real phiso_root
      real*8 frt_gettime
      real*8 frt_spantime
      real*8 tim

      real xl, yl, zl
      real a0, c1, c2, c3, tht, pi
      real xcent, ycent, zcent
      real DONE

c
c debug
      wth(1) = 7.2d0
      wth(2) = 7.2d0
      wth(3) = 7.2d0
      dx = wth(1)/dble(ni) 
      dy = wth(2)/dble(nj) 
      dz = wth(3)/dble(nk) 
      rnu00 = 1.0d0
c debug
c

      DONE = 1.d0

      xl=wth(1)
      yl=wth(2)
      zl=wth(3)
      pi=atan(DONE)*4.0d0

      idx=0
      idy=0
      idz=0
      if( ipara.eq.1 ) then
        call SklGetVoxelHeadIndex(BASE_PARAMANAGER,ID,0,0,idx,ierr)
        call SklGetVoxelHeadIndex(BASE_PARAMANAGER,ID,1,0,idy,ierr)
        call SklGetVoxelHeadIndex(BASE_PARAMANAGER,ID,2,0,idz,ierr)
      endif

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc
      phi(i,j,k)=0.0d0
      enddo
      enddo
      enddo

      nii=30
      njj=30
      nkk=30
c
c<coefficients for the RBC shape
c
      a0= 1.36d0
      c1= 0.207d0
      c2= 2.003d0
      c3=-1.123d0

      tht=0.0d0*pi/180.0d0
      xcent=xl*0.11d0
c<1
      ycent=yl*(0.5d0+0.275d0*cos(tht))
      zcent=zl*(0.5d0+0.275d0*sin(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo
c<2
      ycent=yl*(0.5d0-0.275d0*cos(tht))
      zcent=zl*(0.5d0-0.275d0*sin(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo
      xcent=xl*0.14d0
c<3
      ycent=yl*(0.5d0-0.275d0*sin(tht))
      zcent=zl*(0.5d0+0.275d0*cos(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo
c<4
      ycent=yl*(0.5d0+0.275d0*sin(tht))
      zcent=zl*(0.5d0-0.275d0*cos(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo

      tht=22.5d0*pi/180.0d0
      xcent=xl*0.36d0
c<5
      ycent=yl*(0.5d0+0.275d0*cos(tht))
      zcent=zl*(0.5d0+0.275d0*sin(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo
c<6
      ycent=yl*(0.5d0-0.275d0*cos(tht))
      zcent=zl*(0.5d0-0.275d0*sin(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo

      xcent=xl*0.39d0
c<7
      ycent=yl*(0.5d0-0.275d0*sin(tht))
      zcent=zl*(0.5d0+0.275d0*cos(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo
c<8
      ycent=yl*(0.5d0+0.275d0*sin(tht))
      zcent=zl*(0.5d0-0.275d0*cos(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo

      tht=45.0d0*pi/180.0d0
      xcent=xl*0.61d0
c<9
      ycent=yl*(0.5d0+0.275d0*cos(tht))
      zcent=zl*(0.5d0+0.275d0*sin(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo
c<10
      ycent=yl*(0.5d0-0.275d0*cos(tht))
      zcent=zl*(0.5d0-0.275d0*sin(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo

      xcent=xl*0.64d0
c<11
      ycent=yl*(0.5d0-0.275d0*sin(tht))
      zcent=zl*(0.5d0+0.275d0*cos(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo
c<12
      ycent=yl*(0.5d0+0.275d0*sin(tht))
      zcent=zl*(0.5d0-0.275d0*cos(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo

      tht=67.5d0*pi/180.0d0
      xcent=xl*0.86d0
c<13
      ycent=yl*(0.5d0+0.275d0*cos(tht))
      zcent=zl*(0.5d0+0.275d0*sin(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo
c<14
      ycent=yl*(0.5d0-0.275d0*cos(tht))
      zcent=zl*(0.5d0-0.275d0*sin(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo

      xcent=xl*0.89d0
c<15
      ycent=yl*(0.5d0-0.275d0*sin(tht))
      zcent=zl*(0.5d0+0.275d0*cos(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo
c<16
      ycent=yl*(0.5d0+0.275d0*sin(tht))
      zcent=zl*(0.5d0-0.275d0*cos(tht))
      do k=1,nk
      do j=1,nj
      do i=1,ni
      include'mkrbc.h'
      enddo
      enddo
      enddo

      call SklCommBndCell(phi,vc,ierr)

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc
      phio(i,j,k)=phi(i,j,k)
      enddo
      enddo
      enddo


      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc
c
          uvw(1,i,j,k)=0.0d0
          uvw(2,i,j,k)=0.0d0
          uvw(3,i,j,k)=0.0d0
         uvwo(1,i,j,k)=uvw(1,i,j,k)
         uvwo(2,i,j,k)=uvw(2,i,j,k)
         uvwo(3,i,j,k)=uvw(3,i,j,k)
          p(i,j,k)=0.0d0
       sg(1,i,j,k)=0.0d0
       sg(2,i,j,k)=0.0d0
       sg(3,i,j,k)=0.0d0
       sg(4,i,j,k)=0.0d0
       sg(5,i,j,k)=0.0d0
       sg(6,i,j,k)=0.0d0
      sgo(1,i,j,k)=sg(1,i,j,k)
      sgo(2,i,j,k)=sg(2,i,j,k)
      sgo(3,i,j,k)=sg(3,i,j,k)
      sgo(4,i,j,k)=sg(4,i,j,k)
      sgo(5,i,j,k)=sg(5,i,j,k)
      sgo(6,i,j,k)=sg(6,i,j,k)

       phis_root=sqrt( phi(i,j,k))
      phiso_root=sqrt(phio(i,j,k))

       bl(1,i,j,k)=phis_root
       bl(2,i,j,k)=phis_root
       bl(3,i,j,k)=phis_root
       bl(4,i,j,k)=0.0d0
       bl(5,i,j,k)=0.0d0
       bl(6,i,j,k)=0.0d0
      blo(1,i,j,k)=phiso_root
      blo(2,i,j,k)=phiso_root
      blo(3,i,j,k)=phiso_root
      blo(4,i,j,k)=0.0d0
      blo(5,i,j,k)=0.0d0
      blo(6,i,j,k)=0.0d0
c 
      gravity(1,i,j,k)=grvuvw(1)
      gravity(2,i,j,k)=grvuvw(2)
      gravity(3,i,j,k)=grvuvw(3)
    
      enddo
      enddo
      enddo
ccc
      call bc(ipara,nID,ID,ni,nj,nk,vc,0,uvwo,ftime)
      call bc(ipara,nID,ID,ni,nj,nk,vc,0,uvw,ftime)

      call SklCommBndCell(uvwo,vc,ierr)
      call SklCommBndCell(uvw,vc,ierr)

      call bcsg(ipara,nID,ID,ni,nj,nk,vc,dx,dy,dz,rnu00,sg,uvw,ftime )
      call bcsg(ipara,nID,ID,ni,nj,nk,vc,dx,dy,dz,rnu00,sgo,uvwo,ftime)
ccc

      return
      end

