      subroutine init(ipara,nID,ID,ni,nj,nk,vc,
     1                rnu00,dx,dy,dz,wth,
     2                phi,phio,uvw,uvwo,p,sg,sgo,bl,blo,
     2                gravity,grvuvw,ftime)
c
      implicit none
      include 'sklparaf.h'

cc subroutine arguments
      integer ipara,nID(6),ID
      integer ni,nj,nk,vc
      real rnu00
      real dx,dy,dz,wth(3)
      real phi       (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phio      (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvw     (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvwo    (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real p         (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real sg      (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real sgo     (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real bl      (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real blo     (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real gravity (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

      real grvuvw(3);

      real*8 ftime(10)


cc local variables 
      integer idx,idy,idz,ierr
      integer i,j,k,ii,jj,kk
      integer nii,njj,nkk
      real rads
      real xm1,ym1,zm1
      real xp1,yp1,zp1
      real rmmm,rpmm,rmpm,rppm,rmmp,rpmp,rmpp,rppp
      real dxxii,dyyjj,dzzkk,dvol
      real x00,y00,z00
      real phis_root
      real phiso_root
      real*8 frt_gettime
      real*8 frt_spantime
      real*8 tim

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc
      phi(i,j,k)=0.0d0
      enddo
      enddo
      enddo

      nii=30
      njj=30
      nkk=30
      rads=0.75d0

      idx=0
      idy=0
      idz=0
      if( ipara.eq.1 ) then
        call SklGetVoxelHeadIndex(ID,0,0,idx,ierr)
        call SklGetVoxelHeadIndex(ID,1,0,idy,ierr)
        call SklGetVoxelHeadIndex(ID,2,0,idz,ierr)
      endif

      do k=1,nk
      do j=1,nj
      do i=1,ni

      xm1=dx*dble(i+idx-1)-wth(1)*0.50d0
      ym1=dy*dble(j+idy-1)-wth(2)*0.50d0
      zm1=dz*dble(k+idz-1)-wth(3)*0.50d0
      xp1=dx*dble(i+idx  )-wth(1)*0.50d0
      yp1=dy*dble(j+idy  )-wth(2)*0.50d0
      zp1=dz*dble(k+idz  )-wth(3)*0.50d0

      rmmm=sqrt(xm1**2+ym1**2+zm1**2)
      rpmm=sqrt(xp1**2+ym1**2+zm1**2)
      rmpm=sqrt(xm1**2+yp1**2+zm1**2)
      rppm=sqrt(xp1**2+yp1**2+zm1**2)
      rmmp=sqrt(xm1**2+ym1**2+zp1**2)
      rpmp=sqrt(xp1**2+ym1**2+zp1**2)
      rmpp=sqrt(xm1**2+yp1**2+zp1**2)
      rppp=sqrt(xp1**2+yp1**2+zp1**2)

      if(
     & rmmm.le.rads.and.
     & rpmm.le.rads.and.
     & rmpm.le.rads.and.
     & rppm.le.rads.and.
     & rmmp.le.rads.and.
     & rpmp.le.rads.and.
     & rmpp.le.rads.and.
     & rppp.le.rads     )then
      phi(i,j,k)=1.0d0

      else if(
     & rmmm.le.rads.or.
     & rpmm.le.rads.or.
     & rmpm.le.rads.or.
     & rppm.le.rads.or.
     & rmmp.le.rads.or.
     & rpmp.le.rads.or.
     & rmpp.le.rads.or.
     & rppp.le.rads     )then

      phi(i,j,k)=0.0d0

      dxxii=(xp1-xm1)/dble(nii)
      dyyjj=(yp1-ym1)/dble(njj)
      dzzkk=(zp1-zm1)/dble(nkk)
      dvol=1.0d0/dble(nii*njj*nkk)
      
      do kk=1,nkk
      z00=dzzkk*(dble(kk)-0.5d0)+zm1
      do jj=1,njj
      y00=dyyjj*(dble(jj)-0.5d0)+ym1
      do ii=1,nii
      x00=dxxii*(dble(ii)-0.5d0)+xm1

      if(sqrt(x00**2+y00**2+z00**2).le.rads)then
         phi(i,j,k)=phi(i,j,k)+dvol
      endif
      enddo
      enddo
      enddo

      endif

      enddo
      enddo
      enddo

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc
      phio(i,j,k)=phi(i,j,k)
      enddo
      enddo
      enddo


      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc
c
          uvw(1,i,j,k)=0.0d0
          uvw(2,i,j,k)=0.0d0
          uvw(3,i,j,k)=0.0d0
         uvwo(1,i,j,k)=uvw(1,i,j,k)
         uvwo(2,i,j,k)=uvw(2,i,j,k)
         uvwo(3,i,j,k)=uvw(3,i,j,k)
          p(i,j,k)=0.0d0
       sg(1,i,j,k)=0.0d0
       sg(2,i,j,k)=0.0d0
       sg(3,i,j,k)=0.0d0
       sg(4,i,j,k)=0.0d0
       sg(5,i,j,k)=0.0d0
       sg(6,i,j,k)=0.0d0
      sgo(1,i,j,k)=sg(1,i,j,k)
      sgo(2,i,j,k)=sg(2,i,j,k)
      sgo(3,i,j,k)=sg(3,i,j,k)
      sgo(4,i,j,k)=sg(4,i,j,k)
      sgo(5,i,j,k)=sg(5,i,j,k)
      sgo(6,i,j,k)=sg(6,i,j,k)

       phis_root=sqrt( phi(i,j,k))
      phiso_root=sqrt(phio(i,j,k))

       bl(1,i,j,k)=phis_root
       bl(2,i,j,k)=phis_root
       bl(3,i,j,k)=phis_root
       bl(4,i,j,k)=0.0d0
       bl(5,i,j,k)=0.0d0
       bl(6,i,j,k)=0.0d0
      blo(1,i,j,k)=phiso_root
      blo(2,i,j,k)=phiso_root
      blo(3,i,j,k)=phiso_root
      blo(4,i,j,k)=0.0d0
      blo(5,i,j,k)=0.0d0
      blo(6,i,j,k)=0.0d0
c 
      gravity(1,i,j,k)=grvuvw(1)
      gravity(2,i,j,k)=grvuvw(2)
      gravity(3,i,j,k)=grvuvw(3)
    
      enddo
      enddo
      enddo
ccc
      call bc(ipara,nID,ID,ni,nj,nk,vc,0,uvwo,ftime)
      call bc(ipara,nID,ID,ni,nj,nk,vc,0,uvw,ftime)

      call SklCommBndCell(uvwo,vc,ierr)
      call SklCommBndCell(uvw,vc,ierr)

      call bcsg(ipara,nID,ID,ni,nj,nk,vc,dx,dy,dz,rnu00,sg,uvw,ftime )
      call bcsg(ipara,nID,ID,ni,nj,nk,vc,dx,dy,dz,rnu00,sgo,uvwo,ftime)
ccc

      return
      end

