      subroutine mkpost(vc,ni,nj,nk,nstep,time,dx,dy,dz,
     1  p,phi,uvw,sg,x4,y4,z4,f4,p4,uvw4)
c
      implicit none
      character*32 fname

cc subroutine arguments
      integer vc
      integer ni,nj,nk
      integer nstep
      real time
      real dx,dy,dz
      real p    (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phi  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvw(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real sg (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real*4 x4(ni+1,nj+1,nk)
      real*4 y4(ni+1,nj+1,nk)
      real*4 z4(ni+1,nj+1,nk)
      real*4 f4(ni+1,nj+1,nk)
      real*4 p4(ni+1,nj+1,nk)
      real*4 uvw4(3,0:ni,0:nj,0:nk)
c      real*4 u4(ni+1,nj+1,nk)
c      real*4 v4(ni+1,nj+1,nk)
c      real*4 w4(ni+1,nj+1,nk)

cc local variables 
      integer i,j,k,n
      integer nii,njj,nkk
      real dvdx,dudy,omg
c
      do k=1,nk
      do j=1,nj
      do i=1,ni
      x4(i,j,k)=real((dble(i)-0.5d0))
      y4(i,j,k)=real((dble(j)-0.5d0))
      z4(i,j,k)=real((dble(k)-0.5d0))
      f4(i,j,k)=real(phi(i,j,k))
      p4(i,j,k)=real(p(i,j,k))
      enddo
      enddo
      enddo

      do k=0,nk
      do j=0,nj
      do i=0,ni
      do n=1,3
      uvw4(n,i,j,k)=real(uvw(n,i,j,k))
      enddo
      enddo
      enddo
      enddo

      open(10,file='gdat1',form='unformatted')
      write(10)ni,nj,nk
      write(10)
     1  (((x4(i,j,k),i=1,ni),j=1,nj),k=1,nk)
     2 ,(((y4(i,j,k),i=1,ni),j=1,nj),k=1,nk)
     3 ,(((z4(i,j,k),i=1,ni),j=1,nj),k=1,nk)
      close(10)

      write(fname,'("fdat1",I7.7)')nstep
      open(10,file=fname,form='unformatted')
      write(10)ni,nj,nk
      write(10)1,0
      write(10)
     1 (((f4(i,j,k),i=1,ni),j=1,nj),k=1,nk)
      write(10)
      close(10)

      nii=ni+1
      njj=nj+1
      nkk=1

      k=nk/2
      do j=0,nj
      do i=0,ni
      x4(i+1,j+1,1)=real(dble(i   ))
      y4(i+1,j+1,1)=real(dble(j   ))
      z4(i+1,j+1,1)=real(dble(nk/2)-0.5d0)
      dudy=(uvw(1,i,j+1,k)-uvw(1,i,j,k))/dy
      dvdx=(uvw(2,i+1,j,k)-uvw(2,i,j,k))/dx
      omg=dvdx-dudy
      f4(i+1,j+1,1)=real(omg)
      enddo
      enddo

      open(10,file='gdat2',form='unformatted')
      write(10)nii,njj,nkk
      write(10)
     1  (((x4(i,j,k),i=1,nii),j=1,njj),k=1,nkk)
     2 ,(((y4(i,j,k),i=1,nii),j=1,njj),k=1,nkk)
     3 ,(((z4(i,j,k),i=1,nii),j=1,njj),k=1,nkk)
      close(10)

      write(fname,'("fdat2",I7.7)')nstep
      open(10,file=fname,form='unformatted')
      write(10)nii,njj,nkk
      write(10)1,0
      write(10)
     1 (((f4(i,j,k),i=1,nii),j=1,njj),k=1,nkk)
      write(10)
      close(10)

      nii=ni+1
      njj=1
      nkk=nk
      j=0
      do k=1,nk
      do i=0,ni
      x4(i+1,1,k)=real(dble(i)      )
      y4(i+1,1,k)=real(dble(j)      )
      z4(i+1,1,k)=real(dble(k)-0.5d0)
      f4(i+1,1,k)=real(sg(4,i,j,k)  )
      enddo
      enddo

      open(10,file='gdat3',form='unformatted')
      write(10)nii,njj,nkk
      write(10)
     1  (((x4(i,j,k),i=1,nii),j=1,njj),k=1,nkk)
     2 ,(((y4(i,j,k),i=1,nii),j=1,njj),k=1,nkk)
     3 ,(((z4(i,j,k),i=1,nii),j=1,njj),k=1,nkk)
      close(10)

      write(fname,'("fdat3",I7.7)')nstep
      open(10,file=fname,form='unformatted')
      write(10)nii,njj,nkk
      write(10)1,0
      write(10)
     1 (((f4(i,j,k),i=1,nii),j=1,njj),k=1,nkk)
      write(10)
      close(10)

      nii=ni+1
      njj=1
      nkk=nk
      j=nj
      do k=1,nk
      do i=0,ni
      x4(i+1,1,k)=real(dble(i)      )
      y4(i+1,1,k)=real(dble(j)      )
      z4(i+1,1,k)=real(dble(k)-0.5d0)
      f4(i+1,1,k)=real(sg(4,i,j,k)  )
      enddo
      enddo

      open(10,file='gdat4',form='unformatted')
      write(10)nii,njj,nkk
      write(10)
     1  (((x4(i,j,k),i=1,nii),j=1,njj),k=1,nkk)
     2 ,(((y4(i,j,k),i=1,nii),j=1,njj),k=1,nkk)
     3 ,(((z4(i,j,k),i=1,nii),j=1,njj),k=1,nkk)
      close(10)

      write(fname,'("fdat4",I7.7)')nstep
      open(10,file=fname,form='unformatted')
      write(10)nii,njj,nkk
      write(10)1,0
      write(10)
     1 (((f4(i,j,k),i=1,nii),j=1,njj),k=1,nkk)
      write(10)
      close(10)

      return
      end
