      subroutine mkuvp(vc,ni,nj,nk,nstep,dx,dy,dz,p,phi,uvw,REAL_MIN)
      implicit none

cc subroutine arguments     
      integer vc
      integer nstep
      integer ni,nj,nk
      real dx,dy,dz
      real p    (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phi  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvw(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real REAL_MIN

cc local variables
      character*32 fname
      integer i,j,k
      real x00,y00,z00,p00,q00,u00,v00,w00
      real u1,v1,w1
      real dudy,dvdx
      real omg

      write(fname,'("uvwp",I7.7)')nstep
      open(10,file=fname)
c
      k=nk/2
      do i=1,ni
      x00=(dble(i)-0.5d0)*dx
      do j=1,nj
      y00=(dble(j)-0.5d0)*dy
ccc      do k=1,nk
      z00=(dble(k)-0.5d0)*dz
c
      p00=  p(i,j,k)
      q00=phi(i,j,k)
c
      u1=uvw(1,i-1,j  ,k  )+uvw(1,i,j,k)
      v1=uvw(2,i  ,j-1,k  )+uvw(2,i,j,k)
      w1=uvw(3,i  ,j  ,k-1)+uvw(3,i,j,k)
c
      u00=u1*0.5d0
      v00=v1*0.5d0
      w00=w1*0.5d0

c      if(abs(u00).lt.1.0d-40)u00=0.0d0
c      if(abs(v00).lt.1.0d-40)v00=0.0d0
c      if(abs(w00).lt.1.0d-40)w00=0.0d0
c      if(abs(p00).lt.1.0d-40)p00=0.0d0
c      if(abs(q00).lt.1.0d-40)q00=0.0d0

      if(abs(u00).lt.REAL_MIN)u00=0.0d0
      if(abs(v00).lt.REAL_MIN)v00=0.0d0
      if(abs(w00).lt.REAL_MIN)w00=0.0d0
      if(abs(p00).lt.REAL_MIN)p00=0.0d0
      if(abs(q00).lt.REAL_MIN)q00=0.0d0
c
      write(10,'(8e15.5)')x00,y00,z00,u00,v00,w00,p00,q00
ccc      enddo
      enddo
      write(10,*)
      enddo      
c
      write(fname,'("omg",I7.7)')nstep
      open(10,file=fname)
c
      k=nk/2
      do i=0,ni
      x00=dble(i)*dx
      do j=0,nj
      y00=dble(j)*dy
      dudy=(uvw(1,i,j+1,k)-uvw(1,i,j,k))/dy
      dvdx=(uvw(2,i+1,j,k)-uvw(2,i,j,k))/dx
      omg=dvdx-dudy
      if(abs(omg).lt.1.0d-40)omg=0.0d0

      write(10,'(20e15.5)')
     1  x00
     2 ,y00
     3 ,omg
     4 ,dvdx
     5 ,dudy
      enddo
      write(10,*)
      enddo      
      close(10)
c
      return
      end
