ccc
ccc<SOR method is used in solving the pressure field.
ccc
      subroutine solp_sor(ipara,ID,nID,vsall,vc,ni,nj,nk,
     1  itersor,icherr,imon_t,nstep,
     2  sorbeta,soreps,dx,dy,dz,div,p,rlog,ilog,ftime,itersort)

      implicit none
      include 'sklparaf.h'
      include 'param.h'

ccc<variables for SOR

cc subroutine arguments
      integer ipara,ID,nID(6)
      integer vc,vsall(3)
      integer ni,nj,nk
      integer itersor,icherr,imon_t,nstep
      real sorbeta,soreps
      real dx,dy,dz
      real div(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real p  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real rlog(43)      
      integer ilog(5)
      real*8 ftime(10)
      integer itersort

cc local variables
      integer ierr
      integer i,j,k,m
      integer iter
      real dx2,dy2,dz2
      real dxi22,dyi22,dzi22,d0
      real err
      real dp
      real sump,avp
      real*8 sendbuf(2),recvbuf(2)
      real*8 frt_gettime
      real*8 frt_spantime
      real*8 tim,tim1

c      do k=1-vc,nk+vc
c      do j=1-vc,nj+vc
c      do i=1-vc,ni+vc
c      p(i,j,k)=0.0
c      enddo
c      enddo
c      enddo

      dx2 = dx**2
      dy2 = dy**2
      dz2 = dz**2

      dxi22 = 1.0/dx2
      dyi22 = 1.0/dy2
      dzi22 = 1.0/dz2
      d0 = (dx2*dy2*dz2)/(dx2*dy2+dy2*dz2+dz2*dx2)/2.0

      iter = 0
      do m=1,itersor
        include 'bcp_sor.h'
        iter = m

        err = 0.0
        do k=1,nk
        do j=1,nj
        do i=1,ni
          dp = d0 * ( p(i-1,j  ,k  ) * dxi22
     +              + p(i  ,j-1,k  ) * dyi22
     +              + p(i  ,j  ,k-1) * dzi22
     +              + p(i+1,j  ,k  ) * dxi22
     +              + p(i  ,j+1,k  ) * dyi22
     +              + p(i  ,j  ,k+1) * dzi22
     +              - div(i,j,k) )
          dp = dp - p(i,j,k)
          p(i,j,k) = p(i,j,k) + sorbeta * dp

          err = err + dp**2

        enddo
        enddo
        enddo

        tim=frt_gettime()
        call SklCommBndCell(p,1,ierr)
        ftime(4)=ftime(4)+frt_spantime(tim)

        sendbuf(1) = err
        recvbuf(1) = err

        tim=frt_gettime()
        call SklAllreduce(sendbuf,recvbuf,1,SKL_REAL8,SKL_SUM,0,ierr)
        ftime(4)=ftime(4)+frt_spantime(tim)

        err = recvbuf(1)

        err = sqrt(err)

        if( err .lt. soreps ) exit
      enddo

ccc<impose boundary condition
      include'bcp.h'
c
      tim=frt_gettime()
      call SklCommBndCell(p,1,ierr)
      ftime(4)=ftime(4)+frt_spantime(tim)

ccc
ccc<display ratio of rms error after solving the pressure equation
ccc to that before solving it.
ccc
      if(icherr.eq.1.and.mod(nstep,imon_t).eq.0)then
c      if( ID == 0 ) then
c      write(*,'("Err_p ",e15.5, ", iter ",i5)')err, iter
c      endif

      rlog(19)=err
      ilog(4)=iter

      endif

      itersort=itersort+iter
ccc
      return
      end

c -------------------------------------------------------------
