ccc
ccc<SOR method is used in solving the pressure field.
ccc
      subroutine solp_sor4(ipara,ID,nID,vsall,vc,ni,nj,nk,
     1  itersor,icherr,imon_t,nstep,
     2  sorbeta,soreps,dx,dy,dz,div,p,
     3  idx_si,idx_sj,idx_sk,
     4  recvib,recvjb,recvkb,sendib,sendjb,sendkb,buffsz,
     5  rlog,ilog,ftime,itersort)


      implicit none
      include 'sklparaf.h'
      include 'param.h'
 

ccc<variables for SOR

cc subroutine arguments
      integer idx_si(8),idx_sj(8),idx_sk(8)
      integer ipara,ID,nID(6)
      integer vc,vsall(3)
      integer ni,nj,nk
      integer itersor,icherr,imon_t,nstep
      real sorbeta,soreps
      real dx,dy,dz
      real div(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real p  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

      integer buffsz(3)
      real recvib(buffsz(1),2),sendib(buffsz(1),2)
      real recvjb(buffsz(2),2),sendjb(buffsz(2),2)
      real recvkb(buffsz(3),2),sendkb(buffsz(3),2)

      real rlog(43)
      integer ilog(5)
      real*8 ftime(10)
      integer itersort 

cc local variables
      integer ierr
      integer i,j,k,m
      integer iter
      real dx2,dy2,dz2
      real dxi22,dyi22,dzi22,d0
      real err
      real dp
      real sump,avp
      real*8 sendbuf(2),recvbuf(2)
      real*8 frt_gettime
      real*8 frt_spantime
      real*8 tim,tim1

      integer key(6,2)

c      do k=1-vc,nk+vc
c      do j=1-vc,nj+vc
c      do i=1-vc,ni+vc
c      p(i,j,k)=0.0
c      enddo
c      enddo
c      enddo

      dx2 = dx**2
      dy2 = dy**2
      dz2 = dz**2

      dxi22 = 1.0/dx2
      dyi22 = 1.0/dy2
      dzi22 = 1.0/dz2
      d0 = (dx2*dy2*dz2)/(dx2*dy2+dy2*dz2+dz2*dx2)/2.0

      iter = 0
      do m=1,itersor
        include 'bcp_sor.h'
        iter = m

        err = 0.0

cc Color 1
        do k=idx_sk(1),nk,2
        do j=idx_sj(1),nj,2
        do i=idx_si(1),ni,2
          dp = d0 * ( p(i-1,j  ,k  ) * dxi22
     +              + p(i  ,j-1,k  ) * dyi22
     +              + p(i  ,j  ,k-1) * dzi22
     +              + p(i+1,j  ,k  ) * dxi22
     +              + p(i  ,j+1,k  ) * dyi22
     +              + p(i  ,j  ,k+1) * dzi22
     +              - div(i,j,k) )
          dp = dp - p(i,j,k)
          p(i,j,k) = p(i,j,k) + sorbeta * dp

          err = err + dp**2

        enddo
        enddo
        enddo

        tim=frt_gettime()
        call commface(ni,nj,nk,vc,p,nID,
     +                recvib,recvjb,recvkb,sendib,sendjb,sendkb,buffsz,
     +                key,idx_si(1),idx_sj(1),idx_sk(1),
     +                SKL_DEFAULT_GROUP)
        ftime(5)=ftime(5)+frt_spantime(tim)

        do k=idx_sk(2),nk,2
        do j=idx_sj(2),nj,2
        do i=idx_si(2),ni,2
          dp = d0 * ( p(i-1,j  ,k  ) * dxi22
     +              + p(i  ,j-1,k  ) * dyi22
     +              + p(i  ,j  ,k-1) * dzi22
     +              + p(i+1,j  ,k  ) * dxi22
     +              + p(i  ,j+1,k  ) * dyi22
     +              + p(i  ,j  ,k+1) * dzi22
     +              - div(i,j,k) )
          dp = dp - p(i,j,k)
          p(i,j,k) = p(i,j,k) + sorbeta * dp

          err = err + dp**2

        enddo
        enddo
        enddo

        tim=frt_gettime()
        call commface_wait(ni,nj,nk,vc,p,
     +                     recvib,recvjb,recvkb,buffsz,key,
     +                     idx_si(1),idx_sj(1),idx_sk(1))
        call commface(ni,nj,nk,vc,p,nID,
     +                recvib,recvjb,recvkb,sendib,sendjb,sendkb,buffsz,
     +                key,idx_si(2),idx_sj(2),idx_sk(2),
     +                SKL_DEFAULT_GROUP)
        ftime(5)=ftime(5)+frt_spantime(tim)

cc Color 2
        do k=idx_sk(3),nk,2
        do j=idx_sj(3),nj,2
        do i=idx_si(3),ni,2
          dp = d0 * ( p(i-1,j  ,k  ) * dxi22
     +              + p(i  ,j-1,k  ) * dyi22
     +              + p(i  ,j  ,k-1) * dzi22
     +              + p(i+1,j  ,k  ) * dxi22
     +              + p(i  ,j+1,k  ) * dyi22
     +              + p(i  ,j  ,k+1) * dzi22
     +              - div(i,j,k) )
          dp = dp - p(i,j,k)
          p(i,j,k) = p(i,j,k) + sorbeta * dp

          err = err + dp**2

        enddo
        enddo
        enddo

        tim=frt_gettime()
        call commface_wait(ni,nj,nk,vc,p,
     +                     recvib,recvjb,recvkb,buffsz,key,
     +                     idx_si(2),idx_sj(2),idx_sk(2))
        call commface(ni,nj,nk,vc,p,nID,
     +                recvib,recvjb,recvkb,sendib,sendjb,sendkb,buffsz,
     +                key,idx_si(3),idx_sj(3),idx_sk(3),
     +                SKL_DEFAULT_GROUP)
        ftime(5)=ftime(5)+frt_spantime(tim)

        do k=idx_sk(4),nk,2
        do j=idx_sj(4),nj,2
        do i=idx_si(4),ni,2
          dp = d0 * ( p(i-1,j  ,k  ) * dxi22
     +              + p(i  ,j-1,k  ) * dyi22
     +              + p(i  ,j  ,k-1) * dzi22
     +              + p(i+1,j  ,k  ) * dxi22
     +              + p(i  ,j+1,k  ) * dyi22
     +              + p(i  ,j  ,k+1) * dzi22
     +              - div(i,j,k) )
          dp = dp - p(i,j,k)
          p(i,j,k) = p(i,j,k) + sorbeta * dp

          err = err + dp**2

        enddo
        enddo
        enddo

        tim=frt_gettime()
        call commface_wait(ni,nj,nk,vc,p,
     +                     recvib,recvjb,recvkb,buffsz,key,
     +                     idx_si(3),idx_sj(3),idx_sk(3))
        call commface(ni,nj,nk,vc,p,nID,
     +                recvib,recvjb,recvkb,sendib,sendjb,sendkb,buffsz,
     +                key,idx_si(4),idx_sj(4),idx_sk(4),
     +                SKL_DEFAULT_GROUP)
        ftime(5)=ftime(5)+frt_spantime(tim)

cc Color 3
        do k=idx_sk(5),nk,2
        do j=idx_sj(5),nj,2
        do i=idx_si(5),ni,2
          dp = d0 * ( p(i-1,j  ,k  ) * dxi22
     +              + p(i  ,j-1,k  ) * dyi22
     +              + p(i  ,j  ,k-1) * dzi22
     +              + p(i+1,j  ,k  ) * dxi22
     +              + p(i  ,j+1,k  ) * dyi22
     +              + p(i  ,j  ,k+1) * dzi22
     +              - div(i,j,k) )
          dp = dp - p(i,j,k)
          p(i,j,k) = p(i,j,k) + sorbeta * dp

          err = err + dp**2

        enddo
        enddo
        enddo

        tim=frt_gettime()
        call commface_wait(ni,nj,nk,vc,p,
     +                     recvib,recvjb,recvkb,buffsz,key,
     +                     idx_si(4),idx_sj(4),idx_sk(4))
        call commface(ni,nj,nk,vc,p,nID,
     +                recvib,recvjb,recvkb,sendib,sendjb,sendkb,buffsz,
     +                key,idx_si(5),idx_sj(5),idx_sk(5),
     +                SKL_DEFAULT_GROUP)
        ftime(5)=ftime(5)+frt_spantime(tim)

        do k=idx_sk(6),nk,2
        do j=idx_sj(6),nj,2
        do i=idx_si(6),ni,2
          dp = d0 * ( p(i-1,j  ,k  ) * dxi22
     +              + p(i  ,j-1,k  ) * dyi22
     +              + p(i  ,j  ,k-1) * dzi22
     +              + p(i+1,j  ,k  ) * dxi22
     +              + p(i  ,j+1,k  ) * dyi22
     +              + p(i  ,j  ,k+1) * dzi22
     +              - div(i,j,k) )
          dp = dp - p(i,j,k)
          p(i,j,k) = p(i,j,k) + sorbeta * dp

          err = err + dp**2

        enddo
        enddo
        enddo

        tim=frt_gettime()
        call commface_wait(ni,nj,nk,vc,p,
     +                     recvib,recvjb,recvkb,buffsz,key,
     +                     idx_si(5),idx_sj(5),idx_sk(5))
        call commface(ni,nj,nk,vc,p,nID,
     +                recvib,recvjb,recvkb,sendib,sendjb,sendkb,buffsz,
     +                key,idx_si(6),idx_sj(6),idx_sk(6),
     +                SKL_DEFAULT_GROUP)
        ftime(5)=ftime(5)+frt_spantime(tim)

cc Color 4
        do k=idx_sk(7),nk,2
        do j=idx_sj(7),nj,2
        do i=idx_si(7),ni,2
          dp = d0 * ( p(i-1,j  ,k  ) * dxi22
     +              + p(i  ,j-1,k  ) * dyi22
     +              + p(i  ,j  ,k-1) * dzi22
     +              + p(i+1,j  ,k  ) * dxi22
     +              + p(i  ,j+1,k  ) * dyi22
     +              + p(i  ,j  ,k+1) * dzi22
     +              - div(i,j,k) )
          dp = dp - p(i,j,k)
          p(i,j,k) = p(i,j,k) + sorbeta * dp

          err = err + dp**2

        enddo
        enddo
        enddo

        tim=frt_gettime()
        call commface_wait(ni,nj,nk,vc,p,
     +                     recvib,recvjb,recvkb,buffsz,key,
     +                     idx_si(6),idx_sj(6),idx_sk(6))
        call commface(ni,nj,nk,vc,p,nID,
     +                recvib,recvjb,recvkb,sendib,sendjb,sendkb,buffsz,
     +                key,idx_si(7),idx_sj(7),idx_sk(7),
     +                SKL_DEFAULT_GROUP)
        ftime(5)=ftime(5)+frt_spantime(tim)

        do k=idx_sk(8),nk,2
        do j=idx_sj(8),nj,2
        do i=idx_si(8),ni,2
          dp = d0 * ( p(i-1,j  ,k  ) * dxi22
     +              + p(i  ,j-1,k  ) * dyi22
     +              + p(i  ,j  ,k-1) * dzi22
     +              + p(i+1,j  ,k  ) * dxi22
     +              + p(i  ,j+1,k  ) * dyi22
     +              + p(i  ,j  ,k+1) * dzi22
     +              - div(i,j,k) )
          dp = dp - p(i,j,k)
          p(i,j,k) = p(i,j,k) + sorbeta * dp

          err = err + dp**2

        enddo
        enddo
        enddo

        tim=frt_gettime()
        call commface_wait(ni,nj,nk,vc,p,
     +                     recvib,recvjb,recvkb,buffsz,key,
     +                     idx_si(7),idx_sj(7),idx_sk(7))
        call commface(ni,nj,nk,vc,p,nID,
     +                recvib,recvjb,recvkb,sendib,sendjb,sendkb,buffsz,
     +                key,idx_si(8),idx_sj(8),idx_sk(8),
     +                SKL_DEFAULT_GROUP)
        call commface_wait(ni,nj,nk,vc,p,
     +                     recvib,recvjb,recvkb,buffsz,key,
     +                     idx_si(8),idx_sj(8),idx_sk(8))
        ftime(5)=ftime(5)+frt_spantime(tim)

        sendbuf(1) = err
        recvbuf(1) = err

        tim=frt_gettime()
        call SklAllreduce(sendbuf,recvbuf,1,SKL_REAL8,SKL_SUM,0,ierr)
        ftime(5)=ftime(5)+frt_spantime(tim)

        err = recvbuf(1)

        err = sqrt(err)

        if( err .lt. soreps ) exit
      enddo

ccc<impose boundary condition
      include'bcp.h'
c
      tim=frt_gettime()
      call SklCommBndCell(p,1,ierr)
      ftime(5)=ftime(5)+frt_spantime(tim)

ccc
ccc<display ratio of rms error after solving the pressure equation
ccc to that before solving it.
ccc
      if(icherr.eq.1.and.mod(nstep,imon_t).eq.0)then
c      if( ID == 0 ) then
c      write(*,'("Err_p ",e15.5, ", iter ",i5)')err, iter
c      endif

      rlog(21)=err
      ilog(5)=iter
      endif
 
      itersort=itersort+iter
ccc

      return
      end

c -------------------------------------------------------------
