      subroutine solphi(ipara,nID,ID,vsall,vc,ni,nj,nk,
     1                  icherr,nstep,imon_t,
     2                  time,dt,dx,dy,dz,
     3                  phi,phio,phin,uvw,uvwo,
     4                  REAL_MIN,rlog,ftime)
c
      implicit none
      include 'sklparaf.h'
      include 'param.h'

cc subroutine arguments
      integer vsall(3)
      integer ipara,nID(6),ID
      integer vc
      integer ni,nj,nk
      integer nstep,icherr,imon_t
      real dt,time
      real dx,dy,dz
      real phi   (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phio  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phin  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvw (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvwo(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real REAL_MIN
      real rlog(43)
      real*8 ftime(10)

cc local variables 
      integer ierr
      integer i,j,k
      real dxinv,dyinv,dzinv 
      real verysmall,av,sum     
      real d1_12
      real dx12inv,dy12inv,dz12inv
      real dfxm_1,dfxm_2,dfxm_3
      real dfym_1,dfym_2,dfym_3
      real dfzm_1,dfzm_2,dfzm_3
      real dfxp_1,dfxp_2,dfxp_3
      real dfyp_1,dfyp_2,dfyp_3
      real dfzp_1,dfzp_2,dfzp_3
      real dfxm1,dfxm3,dfxm5
      real dfxp1,dfxp3,dfxp5
      real dfym1,dfym3,dfym5
      real dfyp1,dfyp3,dfyp5
      real dfzm1,dfzm3,dfzm5
      real dfzp1,dfzp3,dfzp5
      real sxm_1,sxm_2,sxm_3
      real sym_1,sym_2,sym_3
      real szm_1,szm_2,szm_3
      real sxp_1,sxp_2,sxp_3
      real syp_1,syp_2,syp_3
      real szp_1,szp_2,szp_3
      real axm_1,axm_2,axm_3
      real aym_1,aym_2,aym_3
      real azm_1,azm_2,azm_3
      real axp_1,axp_2,axp_3
      real ayp_1,ayp_2,ayp_3
      real azp_1,azp_2,azp_3
      real deninv_axm,deninv_aym,deninv_azm
      real deninv_axp,deninv_ayp,deninv_azp
      real wgxm_1,wgxm_2,wgxm_3
      real wgym_1,wgym_2,wgym_3
      real wgzm_1,wgzm_2,wgzm_3
      real wgxp_1,wgxp_2,wgxp_3
      real wgyp_1,wgyp_2,wgyp_3
      real wgzp_1,wgzp_2,wgzp_3
      real uab,vab,wab
      real uxm1,uxp1,vym1,vyp1,wzm1,wzp1
      real adxm1,adxp1,adym1,adyp1,adzm1,adzp1,ad,ado
      real u00,v00,w00
      real*8 sendbuf,recvbuf
      real DONE,DZERO
      real*8 frt_gettime
      real*8 frt_spantime
      real*8 tim
c
      DONE=1.0d0
      DZERO=0.0d0
c
      dxinv=1.0d0/dx
      dyinv=1.0d0/dy
      dzinv=1.0d0/dz

c      verysmall=1.0d-80
      verysmall=REAL_MIN
      d1_12= 1.0d0/12.0d0
      dx12inv=dxinv*d1_12
      dy12inv=dyinv*d1_12
      dz12inv=dzinv*d1_12

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ PRIVATE(dfxm5,dfxm3,dfxm1,dfxp1,dfxp3,dfxp5)
!$OMP$ PRIVATE(dfym5,dfym3,dfym1,dfyp1,dfyp3,dfyp5)
!$OMP$ PRIVATE(dfzm5,dfzm3,dfzm1,dfzp1,dfzp3,dfzp5)
!$OMP$ PRIVATE(u00,v00,w00)
!$OMP$ PRIVATE(dfxm_1,dfxm_2,dfxm_3)
!$OMP$ PRIVATE(dfym_1,dfym_2,dfym_3)
!$OMP$ PRIVATE(dfzm_1,dfzm_2,dfzm_3)
!$OMP$ PRIVATE(dfxp_1,dfxp_2,dfxp_3)
!$OMP$ PRIVATE(dfyp_1,dfyp_2,dfyp_3)
!$OMP$ PRIVATE(dfzp_1,dfzp_2,dfzp_3)
!$OMP$ PRIVATE(sxm_1,sxm_2,sxm_3)
!$OMP$ PRIVATE(sym_1,sym_2,sym_3)
!$OMP$ PRIVATE(szm_1,szm_2,szm_3)
!$OMP$ PRIVATE(sxp_1,sxp_2,sxp_3)
!$OMP$ PRIVATE(syp_1,syp_2,syp_3)
!$OMP$ PRIVATE(szp_1,szp_2,szp_3)
!$OMP$ PRIVATE(axm_1,axm_2,axm_3)
!$OMP$ PRIVATE(aym_1,aym_2,aym_3)
!$OMP$ PRIVATE(azm_1,azm_2,azm_3)
!$OMP$ PRIVATE(axp_1,axp_2,axp_3)
!$OMP$ PRIVATE(ayp_1,ayp_2,ayp_3)
!$OMP$ PRIVATE(azp_1,azp_2,azp_3)
!$OMP$ PRIVATE(deninv_axm,deninv_aym,deninv_azm)
!$OMP$ PRIVATE(deninv_axp,deninv_ayp,deninv_azp)
!$OMP$ PRIVATE(wgxm_1,wgxm_3,wgxm_2)
!$OMP$ PRIVATE(wgym_1,wgym_2,wgym_3)
!$OMP$ PRIVATE(wgzm_1,wgzm_2,wgzm_3)
!$OMP$ PRIVATE(wgxp_1,wgxp_2,wgxp_3)
!$OMP$ PRIVATE(wgyp_1,wgyp_2,wgyp_3)
!$OMP$ PRIVATE(wgzp_1,wgzp_2,wgzp_3)
!$OMP$ PRIVATE(uab,vab,wab)
!$OMP$ PRIVATE(uxm1,uxp1,vym1,vyp1,wzm1,wzp1)
!$OMP$ PRIVATE(adxm1,adxp1,adym1,adyp1,adzm1,adzp1)
!$OMP$ PRIVATE(ad,ado)
!$OMP$ SHARED(u,v,w,uo,vo,wo)
!$OMP$ SHARED(dxinv,dyinv,dzinv,dt,verysmall)
!$OMP$ SHARED(dx12inv,dy12inv,dz12inv)
!$OMP$ SHARED(phi,phio,phin)
!$OMP$ SHARED(DONE,DZERO)
      do k=1,nk
      do j=1,nj
      do i=1,ni

      dfxm5=-phi(i-3,j  ,k  )+phi(i-2,j  ,k  )
      dfxm3=-phi(i-2,j  ,k  )+phi(i-1,j  ,k  )
      dfxm1=-phi(i-1,j  ,k  )+phi(i  ,j  ,k  )
      dfxp1=-phi(i  ,j  ,k  )+phi(i+1,j  ,k  )
      dfxp3=-phi(i+1,j  ,k  )+phi(i+2,j  ,k  )
      dfxp5=-phi(i+2,j  ,k  )+phi(i+3,j  ,k  )
      dfym5=-phi(i  ,j-3,k  )+phi(i  ,j-2,k  )
      dfym3=-phi(i  ,j-2,k  )+phi(i  ,j-1,k  )
      dfym1=-phi(i  ,j-1,k  )+phi(i  ,j  ,k  )
      dfyp1=-phi(i  ,j  ,k  )+phi(i  ,j+1,k  )
      dfyp3=-phi(i  ,j+1,k  )+phi(i  ,j+2,k  )
      dfyp5=-phi(i  ,j+2,k  )+phi(i  ,j+3,k  )
      dfzm5=-phi(i  ,j  ,k-3)+phi(i  ,j  ,k-2)
      dfzm3=-phi(i  ,j  ,k-2)+phi(i  ,j  ,k-1)
      dfzm1=-phi(i  ,j  ,k-1)+phi(i  ,j  ,k  )
      dfzp1=-phi(i  ,j  ,k  )+phi(i  ,j  ,k+1)
      dfzp3=-phi(i  ,j  ,k+1)+phi(i  ,j  ,k+2)
      dfzp5=-phi(i  ,j  ,k+2)+phi(i  ,j  ,k+3)

      u00=(    uvw(1,i-1,j  ,k  )+  uvw(1,i  ,j  ,k  ))*0.5d0
      v00=(    uvw(2,i  ,j-1,k  )+  uvw(2,i  ,j  ,k  ))*0.5d0
      w00=(    uvw(3,i  ,j  ,k-1)+  uvw(3,i  ,j  ,k  ))*0.5d0
      include'weno5.h'
      ad=adxm1+adxp1+adym1+adyp1+adzm1+adzp1
 
      dfxm5=-phio(i-3,j  ,k  )+phio(i-2,j  ,k  )
      dfxm3=-phio(i-2,j  ,k  )+phio(i-1,j  ,k  )
      dfxm1=-phio(i-1,j  ,k  )+phio(i  ,j  ,k  )
      dfxp1=-phio(i  ,j  ,k  )+phio(i+1,j  ,k  )
      dfxp3=-phio(i+1,j  ,k  )+phio(i+2,j  ,k  )
      dfxp5=-phio(i+2,j  ,k  )+phio(i+3,j  ,k  )
      dfym5=-phio(i  ,j-3,k  )+phio(i  ,j-2,k  )
      dfym3=-phio(i  ,j-2,k  )+phio(i  ,j-1,k  )
      dfym1=-phio(i  ,j-1,k  )+phio(i  ,j  ,k  )
      dfyp1=-phio(i  ,j  ,k  )+phio(i  ,j+1,k  )
      dfyp3=-phio(i  ,j+1,k  )+phio(i  ,j+2,k  )
      dfyp5=-phio(i  ,j+2,k  )+phio(i  ,j+3,k  )
      dfzm5=-phio(i  ,j  ,k-3)+phio(i  ,j  ,k-2)
      dfzm3=-phio(i  ,j  ,k-2)+phio(i  ,j  ,k-1)
      dfzm1=-phio(i  ,j  ,k-1)+phio(i  ,j  ,k  )
      dfzp1=-phio(i  ,j  ,k  )+phio(i  ,j  ,k+1)
      dfzp3=-phio(i  ,j  ,k+1)+phio(i  ,j  ,k+2)
      dfzp5=-phio(i  ,j  ,k+2)+phio(i  ,j  ,k+3)

      u00=(    uvwo(1,i-1,j  ,k  )+  uvwo(1,i  ,j  ,k  ))*0.5d0
      v00=(    uvwo(2,i  ,j-1,k  )+  uvwo(2,i  ,j  ,k  ))*0.5d0
      w00=(    uvwo(3,i  ,j  ,k-1)+  uvwo(3,i  ,j  ,k  ))*0.5d0
      include'weno5.h'
      ado=adxm1+adxp1+adym1+adyp1+adzm1+adzp1

      phin(i,j,k)=phi(i,j,k)-(ad*1.5d0-ado*0.5d0)*dt

      phin(i,j,k)=min(phin(i,j,k),DONE)
      phin(i,j,k)=max(phin(i,j,k),DZERO)

      enddo
      enddo
      enddo
!$OMP END PARALLEL DO
c
      if( nID(Y_MINUS).lt.0) then !Yminus

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(phin)
      do k=1,nk
      do j=1,vc
      do i=1,ni
      phin(i, 1-j,k)=phin(i,     j,k)
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

      endif

      if( nID(Y_PLUS).lt.0 ) then !Yplus

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(phin)
      do k=1,nk
      do j=1,vc
      do i=1,ni
      phin(i,nj+j,k)=phin(i,nj+1-j,k)
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

      endif

c
      if( ipara.eq.1 ) then 

        tim = frt_gettime()
        call SklCommPeriodicBndCell(phin,X_DIR,MINUS2PLUS,vc,ierr)!Xplus
        call SklCommPeriodicBndCell(phin,X_DIR,PLUS2MINUS,vc,ierr)!Xminus
        call SklCommPeriodicBndCell(phin,Z_DIR,PLUS2MINUS,vc,ierr) !Zminus
        call SklCommPeriodicBndCell(phin,Z_DIR,MINUS2PLUS,vc,ierr) !Zplus
        ftime(2) = ftime(2)+frt_spantime(tim)

      elseif( ipara.eq.-1 ) then

c
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(phin)
      do k=1,vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc
      phin(i,j,1 -k)=phin(i,j,nk+1-k)
      phin(i,j,nk+k)=phin(i,j,     k)
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

c
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(phin)
      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1,vc
      phin(ni+i,j,k)=phin(     i,j,k)
      phin(1 -i,j,k)=phin(ni+1-i,j,k)
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

      endif

      tim = frt_gettime()
      call SklCommBndCell(phin,vc,ierr)
      ftime(2) = ftime(2)+frt_spantime(tim)

c
      if(icherr.eq.1.and.mod(nstep,imon_t).eq.0)then
      sum=0.0d0
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(phin)
!$OMP$ REDUCTION(+:sum)
      do k=1,nk
      do j=1,nj
      do i=1,ni
      sum=sum+phin(i,j,k)
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

      sendbuf = sum
      recvbuf = sum

      tim = frt_gettime()
      call SklAllreduce(sendbuf,recvbuf,1,SKL_REAL8,SKL_SUM,0,ierr)
      ftime(2) = ftime(2)+frt_spantime(tim)

      sum =recvbuf  

c      if( ID == 0 ) then      
 
      av=sum/dble(vsall(1)*vsall(2)*vsall(3))
c      write(*,'("AV_PHI ",20e20.10)')
c     1  time
c     2 ,av

c     endif

      rlog(5)=time
      rlog(6)=av

      endif
    
 
      return
      end

