      subroutine solu(ipara,ID,nID,vsall,ni,nj,nk,vc,
     1  imax,icherr,nstep,imon_t,
     1  isor,itersor,sorbeta,soreps,
     2  pi,time,dt,dx,dy,dz,grv,rnu00,gmd00,xl,yl,zl,
     3  uvw,uvwo,uvwn,p,phin,div,sg,sgn,bl,blo,bln,
     4  advsx,advsy,advsz,pk,work,nw,
     5  idx_si,idx_sj,idx_sk,buffsz,
     6  recvib,recvjb,recvkb,sendib,sendjb,sendkb,
     7  REAL_MIN,rlog,ilog,ftime,itersort)
c
      implicit none
      include 'sklparaf.h'
      include 'param.h'

cc subroutine arguments
      integer ipara,ID,nID(6)
      integer vsall(3)
      integer ni,nj,nk,vc
      integer imax,icherr,nstep,imon_t
      real pi,time,dt,rnu00,gmd00
      real dx,dy,dz
      real xl,yl,zl

      real uvw (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvwo(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvwn(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real p     (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phin  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real div   (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real sg  (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real sgn (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real bl  (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real blo (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real bln (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
cc
      real advsx(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real advsy(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real advsz(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real pk   (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

cc
      integer nw
      real work(nw)

      integer isor,itersor
      real    sorbeta,soreps
      integer idx_si(8),idx_sj(8),idx_sk(8)

      integer buffsz(3)
      real recvib(buffsz(1),2),sendib(buffsz(1),2)
      real recvjb(buffsz(2),2),sendjb(buffsz(2),2)
      real recvkb(buffsz(3),2),sendkb(buffsz(3),2)

      real REAL_MIN
      real rlog(43)
      integer ilog(5)
      real*8 ftime(10) 
      integer itersort

cc local variables 
      integer ierr
      integer i,j,k
      integer loop
      integer p21,p22,p23,p24,p25,p26,p27,p28,p29,p30,p31
      real sum1,sum2,av1,av2,sump,avp
      real grv,verysmall,d1_12,vis
      real apx,apy,apz,apxinv,apyinv,apzinv
      real du,dv,dw
      real dx2,dy2,dz2
      real dxinv,dyinv,dzinv
      real dxinv2,dyinv2,dzinv2
      real dxinv2dt,dyinv2dt,dzinv2dt
      real dxdyinvdt,dxdzinvdt,dydzinvdt
      real phis,phif,phis_root
      real e2xxn,e2yyn,e2zzn,e2xyn,e2xzn,e2yzn
      real s2xxn,s2yyn,s2zzn,s2xzn,s2xyn,s2yzn
      real dfxm1,dfxm3,dfxm5
      real dfxp1,dfxp3,dfxp5
      real dfym1,dfym3,dfym5
      real dfyp1,dfyp3,dfyp5
      real dfzm1,dfzm3,dfzm5
      real dfzp1,dfzp3,dfzp5
      real dfxm_1,dfxm_2,dfxm_3
      real dfym_1,dfym_2,dfym_3
      real dfzm_1,dfzm_2,dfzm_3
      real dfxp_1,dfxp_2,dfxp_3
      real dfyp_1,dfyp_2,dfyp_3
      real dfzp_1,dfzp_2,dfzp_3
      real sxm_1,sxm_2,sxm_3
      real sym_1,sym_2,sym_3
      real szm_1,szm_2,szm_3
      real sxp_1,sxp_2,sxp_3
      real syp_1,syp_2,syp_3
      real szp_1,szp_2,szp_3
      real axm_1,axm_2,axm_3
      real aym_1,aym_2,aym_3
      real azm_1,azm_2,azm_3
      real axp_1,axp_2,axp_3
      real ayp_1,ayp_2,ayp_3
      real azp_1,azp_2,azp_3
      real deninv_axm,deninv_aym,deninv_azm
      real deninv_axp,deninv_ayp,deninv_azp
      real wgxm_1,wgxm_2,wgxm_3
      real wgym_1,wgym_2,wgym_3
      real wgzm_1,wgzm_2,wgzm_3
      real wgxp_1,wgxp_2,wgxp_3
      real wgyp_1,wgyp_2,wgyp_3
      real wgzp_1,wgzp_2,wgzp_3
      real uab,vab,wab
      real uxm1,uxp1,vym1,vyp1,wzm1,wzp1
      real adxm1,adxp1,adym1,adyp1,adzm1,adzp1
      real adblxx,adblyy,adblzz,adblxy,adblxz,adblyz
      real adblxxo,adblyyo,adblzzo,adblxyo,adblxzo,adblyzo
      real u00,v00,w00
      real adxm11,adym11,adzm11,adxp11,adyp11,adzp11
      real gdxm11,gdym11,gdzm11,gdxp11,gdyp11,gdzp11
      real adx1,ady1,adz1,adv
      real dpx1,dpy1,dpz1
      real dx12inv,dy12inv,dz12inv
      real gxx,gyy,gzz,gxy,gxz,gyx,gyz,gzx,gzy
      real gxxo,gyyo,gzzo,gxyo,gxzo,gyxo,gyzo,gzxo,gzyo
      real gxxmm,gyymm,gzzmm,gxymm,gxzmm,gyxmm,gzxmm,gyzmm,gzymm
      real gxxmp,gyymp,gzzmp,gxymp,gyxmp,gxzmp,gzxmp,gyzmp,gzymp
      real gxxpm,gyypm,gzzpm,gxypm,gxzpm,gyxpm,gzxpm,gyzpm,gzypm
      real gxxpp,gyypp,gzzpp,gxypp,gyxpp,gxzpp,gzxpp,gyzpp,gzypp
      real gxxmmo,gyymmo,gzzmmo,
     +     gxymmo,gxzmmo,gyxmmo,gzxmmo,gyzmmo,gzymmo
      real gxxmpo,gyympo,gzzmpo,
     +     gxympo,gyxmpo,gxzmpo,gzxmpo,gyzmpo,gzympo
      real gxxpmo,gyypmo,gzzpmo,
     +     gxypmo,gxzpmo,gyxpmo,gzxpmo,gyzpmo,gzypmo
      real gxxppo,gyyppo,gzzppo,
     +     gxyppo,gyxppo,gxzppo,gzxppo,gyzppo,gzyppo
      real blxyn_sq,blxzn_sq,blyzn_sq
      real blxx0,blyy0,blzz0,blxy0,blxz0,blyx0,blyz0,blzx0,blzy0
      real blxxn0,blyyn0,blzzn0,
     +     blxyn0,blxzn0,blyxn0,blyzn0,blzxn0,blzyn0
      real blxymm,blxzmm,blyzmm
      real blxymp,blxzmp,blyzmp
      real blxypm,blxzpm,blyzpm
      real blxypp,blxzpp,blyzpp
      real blxxo0,blyyo0,blzzo0,
     +     blxyo0,blxzo0,blyxo0,blyzo0,blzxo0,blzyo0
      real blxymmo,blxzmmo,blyzmmo
      real blxympo,blxzmpo,blyzmpo
      real blxypmo,blxzpmo,blyzpmo
      real blxyppo,blxzppo,blyzppo
      real dmaxp,dminp
      real*8 sendbuf(2),recvbuf(2)
      real*8 frt_gettime
      real*8 frt_spantime
      real*8 tim
      real tr,d1_3,err,err0
cc
c      d1_3=1.0d0/3.0d0

      dxinv=1.0d0/dx
      dyinv=1.0d0/dy
      dzinv=1.0d0/dz
      dx2=dx**2
      dy2=dy**2
      dz2=dz**2
      dxinv2=1.d0/dx2
      dyinv2=1.d0/dy2
      dzinv2=1.d0/dz2


c      dtinv=1.0d0/dt
c      rnuinv=1.0d0/rnu00
c      gmdinv=1.0d0/gmd00

cc
cc<renew new velocities as current ones
cc
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(uvwn,uvw,pk,p)
!$OMP$ SHARED(sg,sgn)
      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc
c
      uvwn(1,i,j,k)=uvw(1,i,j,k)
      uvwn(2,i,j,k)=uvw(2,i,j,k)
      uvwn(3,i,j,k)=uvw(3,i,j,k)
          pk(i,j,k)=    p(i,j,k)
c
      sgn(1,i,j,k)=sg(1,i,j,k)
      sgn(2,i,j,k)=sg(2,i,j,k)
      sgn(3,i,j,k)=sg(3,i,j,k)
      sgn(4,i,j,k)=sg(4,i,j,k)
      sgn(5,i,j,k)=sg(5,i,j,k)
      sgn(6,i,j,k)=sg(6,i,j,k)
c
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

cc
cc<calculate advection term and part of viscous term 
cc in the 2nd-order Adams-Bashforth method
cc explicit calculation
cc

c
c<u
c
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ PRIVATE(adxp11,adxm11,adyp11,adym11,adzp11,adzm11)
!$OMP$ PRIVATE(gdxp11,gdxm11,gdyp11,gdym11,gdzp11,gdzm11)
!$OMP$ PRIVATE(adx1,ady1,adz1,adv,dpx1)
!$OMP$ SHARED(uvw,uvwo,grv,p)
!$OMP$ SHARED(dxinv,dyinv,dzinv)
!$OMP$ SHARED(advsx,sg)
      do k=1,nk
      do j=1,nj
      do i=1,ni
c
      include'coef_advsu.h'
      include'ad_x.h'
c
      advsx(i,j,k)=-1.5d0*adv
     1  +0.5d0*((-sg(1,i,j  ,k  )+sg(1,i+1,j,k))*dxinv
     2         +(-sg(4,i,j-1,k  )+sg(4,i  ,j,k))*dyinv
     3         +(-sg(5,i,j  ,k-1)+sg(5,i  ,j,k))*dzinv)
c
      include'coef_advsuo.h'
      include'ad_x.h'
c
      advsx(i,j,k)=advsx(i,j,k)+0.5d0*adv
c
c<buoyancy contribution
c
      advsx(i,j,k)=advsx(i,j,k)+grv
c
c<pressure gradient
c
      dpx1=-p(i  ,j,k)+p(i+1,j,k)
c
      advsx(i,j,k)=advsx(i,j,k)-dpx1*dxinv
c
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

c
c<v
c
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ PRIVATE(adxp11,adxm11,adyp11,adym11,adzp11,adzm11)
!$OMP$ PRIVATE(gdxp11,gdxm11,gdyp11,gdym11,gdzp11,gdzm11)
!$OMP$ PRIVATE(adx1,ady1,adz1,adv,dpy1)
!$OMP$ SHARED(uvw,uvwo,p)
!$OMP$ SHARED(dxinv,dyinv,dzinv)
!$OMP$ SHARED(advsy,sg)
      do k=1,nk
      do j=1,nj
      do i=1,ni
c
      include'coef_advsv.h'
      include'ad_y.h'
c
      advsy(i,j,k)=-1.5d0*adv
     1  +0.5d0*((-sg(4,i-1,j,k  )+sg(4,i,j  ,k))*dxinv
     2         +(-sg(2,i  ,j,k  )+sg(2,i,j+1,k))*dyinv
     3         +(-sg(6,i  ,j,k-1)+sg(6,i,j  ,k))*dzinv)
c
      include'coef_advsvo.h'
      include'ad_y.h'
c
      advsy(i,j,k)=advsy(i,j,k)+0.5d0*adv
c
c<pressure gradient
c
      dpy1=-p(i,j,k)+p(i,j+1,k)
c
      advsy(i,j,k)=advsy(i,j,k)-dpy1*dyinv
c
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

c
c<w
c
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ PRIVATE(adxp11,adxm11,adyp11,adym11,adzp11,adzm11)
!$OMP$ PRIVATE(gdxp11,gdxm11,gdyp11,gdym11,gdzp11,gdzm11)
!$OMP$ PRIVATE(adx1,ady1,adz1,adv,dpz1)
!$OMP$ SHARED(uvw,uvwo,p)
!$OMP$ SHARED(dxinv,dyinv,dzinv)
!$OMP$ SHARED(advsz,sg)
      do k=1,nk
      do j=1,nj
      do i=1,ni
c
      include'coef_advsw.h'
      include'ad_z.h'
c
      advsz(i,j,k)=-1.5d0*adv
     1  +0.5d0*((-sg(5,i-1,j  ,k)+sg(5,i,j,k  ))*dxinv
     2         +(-sg(6,i  ,j-1,k)+sg(6,i,j,k  ))*dyinv
     3         +(-sg(3,i  ,j  ,k)+sg(3,i,j,k+1))*dzinv)
c
      include'coef_advswo.h'
      include'ad_z.h'
c
      advsz(i,j,k)=advsz(i,j,k)+0.5d0*adv
c
c<pressure gradient
c
      dpz1=-p(i,j,k)+p(i,j,k+1)
c
      advsz(i,j,k)=advsz(i,j,k)-dpz1*dzinv
c
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

c      write(*,*) "dt     ",dt
c      write(*,*) "dxinv2 ",dxinv2
c      write(*,*) "dyinv2 ",dyinv2
c      write(*,*) "dzinv2 ",dzinv2

ccc
ccc<The 2nd-order Crank-Nicolson method is employed for the stress divergence
ccc
ccc<implicit loop V
ccc
      do loop=0,imax
cc
      err=0.0d0
cc      include 'solsg00.h'
cc      include 'solsgxy.h'
cc      include 'solsgxz.h'
cc      include 'solsgyz.h'
      call solsg(ni,nj,nk,vc,
     1           uvwn,bln,phin,sgn,
     2           dxinv,dyinv,dzinv,rnu00,gmd00
     3           )
c
      call bcsg(ipara,nID,ID,ni,nj,nk,vc,dx,dy,dz,rnu00,sgn,uvwn,ftime)

      tim=frt_gettime()
      call SklCommBndCell(sgn,1,ierr)
      ftime(3)=ftime(3)+frt_spantime(tim)
c
c<un
c
      apx=(
     1   2.0d0*dxinv2
     2 + 2.0d0*dyinv2
     3 + 2.0d0*dzinv2
     & )*rnu00
c
      apxinv=1.0d0/(1.0d0+dt*apx)

c
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ PRIVATE(vis)
!$OMP$ SHARED(dxinv,dyinv,dzinv,dt)
!$OMP$ SHARED(sgn)
!$OMP$ SHARED(uvwn,uvw,du,advsx,apx,apxinv)
!$OMP$ REDUCTION(+:err)
      do k=1,nk
      do j=1,nj
      do i=1,ni

      vis=
     1 +(-sgn(1,i,j  ,k  )+sgn(1,i+1,j,k))*dxinv
     2 +(-sgn(4,i,j-1,k  )+sgn(4,i  ,j,k))*dyinv
     3 +(-sgn(5,i,j  ,k-1)+sgn(5,i  ,j,k))*dzinv
c
      du=-uvwn(1,i,j,k)+(uvw(1,i,j,k)
     1 +dt*(advsx(i,j,k)+0.5d0*vis+uvwn(1,i,j,k)*apx))*apxinv
      uvwn(1,i,j,k)=uvwn(1,i,j,k)+du
c
      err=err+du**2
c
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

c
c<vn
c
      apy=(
     1   2.0d0*dxinv2
     2 + 2.0d0*dyinv2
     3 + 2.0d0*dzinv2
     & )*rnu00
c
      apyinv=1.0d0/(1.0d0+dt*apy)
c
c
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ PRIVATE(vis)
!$OMP$ SHARED(dxinv,dyinv,dzinv,dt)
!$OMP$ SHARED(sgn)
!$OMP$ SHARED(uvwn,uvw,dv,advsy,apy,apyinv)
!$OMP$ REDUCTION(+:err)
      do k=1,nk
      do j=1,nj
      do i=1,ni

      vis=
     1 +(-sgn(4,i-1,j,k  )+sgn(4,i,j  ,k))*dxinv
     2 +(-sgn(2,i  ,j,k  )+sgn(2,i,j+1,k))*dyinv
     3 +(-sgn(6,i  ,j,k-1)+sgn(6,i,j  ,k))*dzinv

      dv=-uvwn(2,i,j,k)+(uvw(2,i,j,k)
     1 +dt*(advsy(i,j,k)+0.5d0*vis+uvwn(2,i,j,k)*apy))*apyinv
      uvwn(2,i,j,k)=uvwn(2,i,j,k)+dv

c      if( i.eq.1 .and. j.eq.1 .and. k.eq.1 ) then
c        write(*,*) "uvwn(2,1,1,1)",uvwn(2,1,1,1)
c        write(*,*) "uvw(2,1,1,1) ",uvw(2,1,1,1)
c        write(*,*) "advsy(1,1,1) ",advsy(1,1,1)
c        write(*,*) "vis          ",vis
c        write(*,*) "apy          ",apy
c        write(*,*) "apyinv       ",apyinv
c        write(*,*) "dt           ",dt
c      endif
c
      err=err+dv**2
c
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

c      write(*,*) "enddo uvwn(2,1,1,1)",uvwn(2,1,1,1)
c
c<wn
c
      apz=(
     1   2.0d0*dxinv2
     2 + 2.0d0*dyinv2
     3 + 2.0d0*dzinv2
     & )*rnu00
c
      apzinv=1.0d0/(1.0d0+dt*apz)
c
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ PRIVATE(vis)
!$OMP$ SHARED(dxinv,dyinv,dzinv,dt)
!$OMP$ SHARED(sgn)
!$OMP$ SHARED(uvwn,uvw,dw,advsz,apz,apzinv)
!$OMP$ REDUCTION(+:err)
      do k=1,nk
      do j=1,nj
      do i=1,ni

      vis=
     1 +(-sgn(5,i-1,j  ,k)+sgn(5,i,j,k  ))*dxinv
     2 +(-sgn(6,i  ,j-1,k)+sgn(6,i,j,k  ))*dyinv
     3 +(-sgn(3,i  ,j  ,k)+sgn(3,i,j,k+1))*dzinv

      dw=-uvwn(3,i,j,k)+(uvw(3,i,j,k)
     1 +dt*(advsz(i,j,k)+0.5d0*vis+uvwn(3,i,j,k)*apz))*apzinv
      uvwn(3,i,j,k)=uvwn(3,i,j,k)+dw
c
      err=err+dw**2
c
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO
cc

      call bc(ipara,nID,ID,ni,nj,nk,vc,nstep,uvwn,ftime)

      tim=frt_gettime()
      call SklCommBndCell(uvwn,1,ierr)

      ftime(3)=ftime(3)+frt_spantime(tim)
cc
      sendbuf(1)=err
      recvbuf(1)=err
      tim=frt_gettime()
      call SklAllreduce(sendbuf,recvbuf,1,SKL_REAL8,SKL_SUM,0,ierr)
      ftime(3)=ftime(3)+frt_spantime(tim)
      err=recvbuf(1)

      err=sqrt(err/dble(vsall(1)*vsall(2)*vsall(3)))
      if(loop.eq.0)err0=err
      if(err/err0.le.1.0d-6)goto 100
      if(mod(loop,100).eq.0)then
      write(*,'("loop= ",1i4.4," err= ",20e20.10)')loop,err
      endif

      enddo
ccc<implicit loop A
 100  continue
      if(icherr.eq.1.and.mod(nstep,imon_t).eq.0)then
        write(*,'("loop= ",1i4.4," err= ",20e20.10)')loop,err
      endif

ccc
ccc<calculate velocity divergence divided by dt
ccc !check the residual error 
ccc
c     write(*,*) "caldiv befor div(1,1,1)",div(1,1,1)
c      write(*,*) "caldiv befor uvwn(2,1,1,1)",uvwn(2,1,1,1)
      call caldiv(ID,vsall,vc,ni,nj,nk,icherr,nstep,imon_t,
     1            dx,dy,dz,dt,time,uvwn,div,rlog,1,ftime)
c     write(*,*) "caldiv after div(1,1,1)",div(1,1,1)
ccc
ccc<solve pressure equation
ccc
      if(isor.eq.1)then  !sor

      call solp_sor(ipara,ID,nID,vsall,vc,ni,nj,nk,
     1  itersor,icherr,imon_t,nstep,
     2  sorbeta,soreps,dx,dy,dz,div,p,rlog,ilog,ftime,itersort)

      elseif(isor.eq.2)then !sor 4 color

      call solp_sor4(ipara,ID,nID,vsall,vc,ni,nj,nk,
     1  itersor,icherr,imon_t,nstep,
     2  sorbeta,soreps,dx,dy,dz,div,p,
     3  idx_si,idx_sj,idx_sk,
     4  recvib,recvjb,recvkb,sendib,sendjb,sendkb,buffsz,
     5  rlog,ilog,ftime,itersort) 

      elseif(isor.eq.3)then !sor 4 color

      call solp_sor4o(ipara,ID,nID,vsall,vc,ni,nj,nk,
     1  itersor,icherr,imon_t,nstep,
     2  sorbeta,soreps,dx,dy,dz,div,p,
     3  idx_si,idx_sj,idx_sk,
     4  rlog,ilog,ftime,itersort);

      endif
ccc
ccc<correct velocities
ccc
      call corun(vc,ni,nj,nk,dt,dx,dy,dz,p,uvwn)
      call bc(ipara,nID,ID,ni,nj,nk,vc,nstep,uvwn,ftime)

      tim=frt_gettime()
      call SklCommBndCell(uvwn,1,ierr)
      ftime(3)=ftime(3)+frt_spantime(tim)

      dxinv2dt=dxinv2*dt
      dyinv2dt=dyinv2*dt
      dzinv2dt=dzinv2*dt
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(p,rnu00)
!$OMP$ SHARED(sgn)
!$OMP$ SHARED(dxinv2dt,dyinv2dt,dzinv2dt)
      do k=1,nk
      do j=1,nj
      do i=1,ni
      sgn(1,i,j,k)=sgn(1,i,j,k)
     & -(p(i-1,j,k)-p(i,j,k)*2.0d0+p(i+1,j,k))
     &  *dxinv2dt*rnu00*2.0d0
      sgn(2,i,j,k)=sgn(2,i,j,k)
     & -(p(i,j-1,k)-p(i,j,k)*2.0d0+p(i,j+1,k))
     &  *dyinv2dt*rnu00*2.0d0
      sgn(3,i,j,k)=sgn(3,i,j,k)
     & -(p(i,j,k-1)-p(i,j,k)*2.0d0+p(i,j,k+1))
     &  *dzinv2dt*rnu00*2.0d0
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

      dxdyinvdt=dxinv*dyinv*dt
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(p,rnu00)
!$OMP$ SHARED(sgn,dxdyinvdt)
      do k=1,nk
      do j=1,nj
      do i=1,ni
      sgn(4,i,j,k)=sgn(4,i,j,k)
     1 -(p(i,j,k)-p(i+1,j,k)-p(i,j+1,k)+p(i+1,j+1,k))
     2 *dxdyinvdt*rnu00*2.0d0
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

      dxdzinvdt=dxinv*dzinv*dt
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(p,rnu00)
!$OMP$ SHARED(sgxzn,dxdzinvdt)
      do k=1,nk
      do j=1,nj
      do i=1,ni
      sgn(5,i,j,k)=sgn(5,i,j,k)
     1 -(p(i,j,k)-p(i+1,j,k)-p(i,j,k+1)+p(i+1,j,k+1))
     2 *dxdzinvdt*rnu00*2.0d0
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

      dydzinvdt=dyinv*dzinv*dt
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(p,rnu00)
!$OMP$ SHARED(sgn,dydzinvdt)
      do k=1,nk
      do j=1,nj
      do i=1,ni
      sgn(6,i,j,k)=sgn(6,i,j,k)
     1 -(p(i,j,k)-p(i,j+1,k)-p(i,j,k+1)+p(i,j+1,k+1))
     2 *dydzinvdt*rnu00*2.0d0
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

      call bcsg(ipara,nID,ID,ni,nj,nk,vc,dx,dy,dz,rnu00,sgn,uvwn,ftime)
      tim=frt_gettime()
      call SklCommBndCell(sgn,1,ierr)
      ftime(3)=ftime(3)+frt_spantime(tim)

      call caldiv(ID,vsall,vc,ni,nj,nk,icherr,nstep,imon_t,
     1            dx,dy,dz,dt,time,uvwn,div,rlog,2,ftime)
ccc
ccc<renew new pressure
ccc

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(pk,p)
      do k=1,nk
      do j=1,nj
      do i=1,ni
      pk(i,j,k)=pk(i,j,k)+p(i,j,k)
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO
c
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(p,pk)
      do k=1,nk
      do j=1,nj
      do i=1,ni
      p(i,j,k)=pk(i,j,k)
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

ccc
ccc<impose boundary condition
ccc

      include 'bcp.h'

      tim=frt_gettime()
      call SklCommBndCell(p,1,ierr)
      ftime(3)=ftime(3)+frt_spantime(tim)
c
      return
      end

c -------------------------------------------------------------

