      subroutine solu2(ipara,ID,nID,vsall,ni,nj,nk,vc,
     1                 imax,nstep,icherr,imon_t,dx,dy,dz,
     2                 dt,time,rnu00,gmd00,
     3                 phin,uvw,uvwn,bln,sgn,advsx,advsy,advsz,
     4                 ftime,rlog)
c
      implicit none
      include 'sklparaf.h'
      include 'param.h'

cc subroutine arguments
      integer ipara,ID,nID(6)
      integer vsall(3),ni,nj,nk,vc
      integer nstep,icherr,imon_t
      real    dx,dy,dz
      real    dt,time
      real    rnu00,gmd00
      integer imax

      real    phin  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real    uvw (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real    uvwn(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real    bln (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real    sgn (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real    advsx (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real    advsy (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real    advsz (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real    div   (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

      real*8  ftime(10)
      real    rlog(43)

cc local variables
      integer loop,i,j,k,ierr
      real    dxinv,dyinv,dzinv
      real*8 tim,frt_gettime,frt_spantime

      real apx,apy,apz,apxinv,apyinv,apzinv
      real vis,du,dv,dw
      real sum1,sum2,av1,av2

      real*8 sendbuf(2),recvbuf(2)

c. solsg00.h
      real s2xxn,s2yyn,s2zzn
      real blxxn0,blyyn0,blzzn0
      real blxyn_sq,blxzn_sq,blyzn_sq
      real phis,phif,phis_root
      real e2xxn,e2yyn,e2zzn

c. solsgxy.h
      real s2xyn,e2xyn
      real blxyn0,blyxn0,blxzn0,blzxn0,blyzn0,blzyn0

c. solsgxz.h
      real s2xzn,e2xzn

c. solsgyz.h
      real s2yzn,e2yzn


c      dx00=dx
c      dx00inv=1.0d0/dx00
c      dy00=dy
c      dy00inv=1.0d0/dy00
c      dz00=dz
c      dz00inv=1.0d0/dz00
c
      dxinv=1.0d0/dx
      dyinv=1.0d0/dy
      dzinv=1.0d0/dz

ccc
ccc<The 2nd-order Crank-Nicolson method is employed for the stress divergence
ccc
ccc<implicit loop V
ccc
      do loop=1,imax
cc
ccc      err=0.0d0

cc      include 'solsg00.h'
cc      include 'solsgxy.h'
cc      include 'solsgxz.h'
cc      include 'solsgyz.h'
      call solsg(ni,nj,nk,vc,
     1           uvwn,bln,phin,sgn,
     2           dxinv,dyinv,dzinv,rnu00,gmd00
     3           )

      call bcsg(ipara,nID,ID,ni,nj,nk,vc,dx,dy,dz,rnu00,sgn,uvwn,ftime)

      tim=frt_gettime()
      call SklCommBndCell(sgn,1,ierr)
      ftime(3)=ftime(3)+frt_spantime(tim)
c
c<un
c
      do k=1,nk
      do j=1,nj
      do i=1,ni
c
      apx=0.0d0
c
      apxinv=1.0d0/(1.0d0+dt*apx)

      vis=
     1 +(sgn(1,i+1,j,k)-sgn(1,i,j  ,k  ))*dxinv
     2 +(sgn(4,i  ,j,k)-sgn(4,i,j-1,k  ))*dyinv
     3 +(sgn(5,i  ,j,k)-sgn(5,i,j  ,k-1))*dzinv
c
      du=-uvwn(1,i,j,k)+(uvw(1,i,j,k)
     1 +dt*(advsx(i,j,k)+0.5d0*vis+uvwn(1,i,j,k)*apx))*apxinv
      uvwn(1,i,j,k)=uvwn(1,i,j,k)+du
c
ccc      err=err+du**2
c
      enddo
      enddo
      enddo
c
c<vn
c
      do k=1,nk
      do j=1,nj
      do i=1,ni
c
      apy=0.0d0
c
      apyinv=1.0d0/(1.0d0+dt*apy)
c
      vis=
     1 +(sgn(4,i,j  ,k)-sgn(4,i-1,j,k  ))*dxinv
     2 +(sgn(2,i,j+1,k)-sgn(2,i  ,j,k  ))*dyinv
     3 +(sgn(6,i,j  ,k)-sgn(6,i  ,j,k-1))*dzinv

      dv=-uvwn(2,i,j,k)+(uvw(2,i,j,k)
     1 +dt*(advsy(i,j,k)+0.5d0*vis+uvwn(2,i,j,k)*apy))*apyinv
      uvwn(2,i,j,k)=uvwn(2,i,j,k)+dv
c
ccc      err=err+dv**2
c
      enddo
      enddo
      enddo

c
c<wn
c
      do k=1,nk
      do j=1,nj
      do i=1,ni
c
      apz=0.0d0
c
      apzinv=1.0d0/(1.0d0+dt*apz)
c
      vis=
     1 +(sgn(5,i,j,k  )-sgn(5,i-1,j  ,k))*dxinv
     2 +(sgn(6,i,j,k  )-sgn(6,i  ,j-1,k))*dyinv
     3 +(sgn(3,i,j,k+1)-sgn(3,i  ,j  ,k))*dzinv

      dw=-uvwn(3,i,j,k)+(uvw(3,i,j,k)
     1 +dt*(advsz(i,j,k)+0.5d0*vis+uvwn(3,i,j,k)*apz))*apzinv
      uvwn(3,i,j,k)=uvwn(3,i,j,k)+dw
c
ccc      err=err+dw**2
c
      enddo
      enddo
      enddo

ccc      if(loop.eq.imax)stop


cc
cc      write(*,*)loop,err/dble(ni*nj)
cc
      call bc(ipara,nID,ID,ni,nj,nk,vc,nstep,uvwn,ftime)

      tim=frt_gettime()
      call SklCommBndCell(uvwn,1,ierr)
      ftime(3)=ftime(3)+frt_spantime(tim)

cc
      enddo


ccc<implicit loop A

      if(icherr.eq.1.and.mod(nstep,imon_t).eq.0)then
      sum1=0.0d0
      sum2=0.0d0
      do k=1,nk
      do j=1,nj
      do i=1,ni
      sum1=sum1+ sgn(1,i,j,k)+sgn(2,i,j,k)+sgn(3,i,j,k)
      sum2=sum2+(sgn(1,i,j,k)+sgn(2,i,j,k)+sgn(3,i,j,k))**2
      enddo
      enddo
      enddo

      sendbuf(1) = sum1
      recvbuf(1) = sum1
      sendbuf(2) = sum2
      recvbuf(2) = sum2

      tim=frt_gettime()
      call SklAllreduce(sendbuf,recvbuf,2,SKL_REAL8,SKL_SUM,0,ierr)
      ftime(3)=ftime(3)+frt_spantime(tim)

 
      sum1 = recvbuf(1)
      sum2 = recvbuf(2)

c     if( ID == 0 ) then

      av1=sum1/dble(vsall(1)*vsall(2)*vsall(3))
      av2=sum2/dble(vsall(1)*vsall(2)*vsall(3))
c      write(*,'("AV_DIAG ",20e20.10)')
c     1  time
c     2 ,av1
c     3 ,sqrt(av2)

c      endif

      rlog(7)=time
      rlog(8)=av1
      rlog(9)=sqrt(av2)

      endif


ccc
ccc<calculate velocity divergence divided by dt
ccc !check the residual error 
ccc

      call caldiv(ID,vsall,vc,ni,nj,nk,icherr,nstep,imon_t,
     1            dx,dy,dz,dt,time,uvwn,div,rlog,1,ftime)

      return
      end

c -------------------------------------------------------------

