      subroutine solu3(ipara,ID,nID,vsall,ni,nj,nk,vc,dx,dy,dz,
     1                 xl,yl,zl,nstep,time,dt,rnu00,pi,
     1                 isor,itersor,sorbeta,soreps,
     1                 idx_si,idx_sj,idx_sk,buffsz,
     1                 recvib,recvjb,recvkb,sendib,sendjb,sendkb,
     1                 
     1                 div,p,pk,phin,uvwn,sgn,work,nw,
     1                 icherr,imon_t,itersort,rlog,ilog,ftime,
     1                 REAL_MIN)
c
      implicit none
      include 'sklparaf.h'
      include 'param.h'

cc subroutine arguments
      integer ipara,ID,nID(6)
      integer vsall(3),ni,nj,nk,vc
      real    dx,dy,dz
      real    xl,yl,zl
      integer nstep
      real    time,dt,rnu00,pi

      integer isor,itersor
      real    sorbeta,soreps
      integer idx_si(8),idx_sj(8),idx_sk(8)
      integer buffsz(3)
      real    recvib(buffsz(1),2),sendib(buffsz(1),2)
      real    recvjb(buffsz(2),2),sendjb(buffsz(2),2)
      real    recvkb(buffsz(3),2),sendkb(buffsz(3),2)

      real    div   (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real    p     (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real    pk    (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real    phin  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real    uvwn(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real    sgn (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

      integer nw
      real    work(nw)

      integer icherr,imon_t,itersort
      real    rlog(43)
      integer ilog(5)
      real*8  ftime(10)
      real    REAL_MIN


cc local variables 
      integer i,j,k,ierr
      integer p01,p02,p03,p04,p05,p06,p07,p08,p09,p10,p11
      real    dxinv,dyinv,dzinv
      real    dxinv2dt,dzinv2dt,dyinv2dt
      real    dxdyinvdt,dxdzinvdt,dydzinvdt
      real    phis,phif
      real    sum1,sum2,av1,av2,sump,avp

      real*8 sendbuf(2),recvbuf(2)
      real*8 tim,frt_gettime,frt_spantime
cc


c      dx00=dx
c      dx00inv=1.0d0/dx00
c      dy00=dy
c      dy00inv=1.0d0/dy00
c      dz00=dz
c      dz00inv=1.0d0/dz00

      dxinv=1.0d0/dx
      dyinv=1.0d0/dy
      dzinv=1.0d0/dz

ccc
ccc<solve pressure equation
ccc
      if(isor.eq.1)then  !sor

        call solp_sor(ipara,ID,nID,vsall,vc,ni,nj,nk,
     1                itersor,icherr,imon_t,nstep,
     2                sorbeta,soreps,dx,dy,dz,div,p,
     3                rlog,ilog,ftime,itersort)

      elseif(isor.eq.2)then !sor 4 color (pack+comm immediate)

        call solp_sor4(ipara,ID,nID,vsall,vc,ni,nj,nk,
     1                 itersor,icherr,imon_t,nstep,
     2                 sorbeta,soreps,dx,dy,dz,div,p,
     3                 idx_si,idx_sj,idx_sk,
     4                 recvib,recvjb,recvkb,sendib,sendjb,sendkb,buffsz,
     5                 rlog,ilog,ftime,itersort) 

      elseif(isor.eq.3)then !sor 4 color (CommBndCell)

        call solp_sor4o(ipara,ID,nID,vsall,vc,ni,nj,nk,
     1                  itersor,icherr,imon_t,nstep,
     2                  sorbeta,soreps,dx,dy,dz,div,p,
     3                  idx_si,idx_sj,idx_sk,
     4                  rlog,ilog,ftime,itersort);

      elseif(isor.eq.0)then !fft
     
        p01=1                    !divh_r
        p02=p01+ni*(nj+2*vc)*nk  !divh_i
        p03=p02+ni*(nj+2*vc)*nk  !phih_r
        p04=p03+ni*(nj+2*vc)*nk  !phih_i
        p05=p04+ni*(nj+2*vc)*nk  !fftdata
        p06=p05+ni*nk*2          !an1
        p07=p06+(nj+2*vc)        !as1
        p08=p07+(nj+2*vc)        !ay0
        p09=p08+(nj+2*vc)        !atdma1
        p10=p09 +(nj+2*vc)        !btdma_r
        p11=p10+(nj+2*vc)        !btdma_i
      
        call solp(ipara,nID,vsall,vc,ni,nj,nk,icherr,nstep,imon_t,
     1            pi,dx,dy,dz,xl,yl,zl,p,div,
     2            work(p01),work(p02),work(p03),work(p04),
     3            work(p05),work(p06),work(p07),work(p08),
     4            work(p09),work(p10),work(p11),
     5            REAL_MIN,rlog,ftime)

      endif
ccc
ccc<correct velocities
ccc
      call corun(vc,ni,nj,nk,dt,dx,dy,dz,p,uvwn)
      call bc(ipara,nID,ID,ni,nj,nk,vc,nstep,uvwn,ftime)

      tim=frt_gettime()
      call SklCommBndCell(uvwn,1,ierr)
      ftime(3)=ftime(3)+frt_spantime(tim)


      dxinv2dt=dxinv**2*dt
      dyinv2dt=dyinv**2*dt
      dzinv2dt=dzinv**2*dt
      do k=1,nk
      do j=1,nj
      do i=1,ni
      phis=phin(i,j,k)
      phif=1.0d0-phis
      sgn(1,i,j,k)=sgn(1,i,j,k)
     & -(p(i-1,j,k)+p(i+1,j,k)-p(i,j,k)*2.0d0)
     &  *dxinv2dt*phif*rnu00*2.0d0
      sgn(2,i,j,k)=sgn(2,i,j,k)
     & -(p(i,j-1,k)+p(i,j+1,k)-p(i,j,k)*2.0d0)
     &  *dyinv2dt*phif*rnu00*2.0d0
      sgn(3,i,j,k)=sgn(3,i,j,k)
     & -(p(i,j,k-1)+p(i,j,k+1)-p(i,j,k)*2.0d0)
     &  *dzinv2dt*phif*rnu00*2.0d0
      enddo
      enddo
      enddo

      dxdyinvdt=dxinv*dyinv*dt
      do k=1,nk
      do j=1,nj
      do i=1,ni
      phis=(
     1 +phin(i  ,j  ,k  )
     2 +phin(i+1,j  ,k  )
     3 +phin(i  ,j+1,k  )
     4 +phin(i+1,j+1,k  ))*0.25d0
      phif=1.0d0-phis
      sgn(4,i,j,k)=sgn(4,i,j,k)
     1 -(p(i,j,k)-p(i+1,j,k)-p(i,j+1,k)+p(i+1,j+1,k))
     2 *dxdyinvdt*phif*rnu00*2.0d0
      enddo
      enddo
      enddo

      dxdzinvdt=dxinv*dzinv*dt
      do k=1,nk
      do j=1,nj
      do i=1,ni
      phis=(
     1 +phin(i  ,j  ,k  )
     2 +phin(i+1,j  ,k  )
     3 +phin(i  ,j  ,k+1)
     4 +phin(i+1,j  ,k+1))*0.25d0
      phif=1.0d0-phis
      sgn(5,i,j,k)=sgn(5,i,j,k)
     1 -(p(i,j,k)-p(i+1,j,k)-p(i,j,k+1)+p(i+1,j,k+1))
     2 *dxdzinvdt*phif*rnu00*2.0d0
      enddo
      enddo
      enddo

      dydzinvdt=dyinv*dzinv*dt
      do k=1,nk
      do j=1,nj
      do i=1,ni
      phis=(
     1 +phin(i  ,j  ,k  )
     2 +phin(i  ,j+1,k  )
     3 +phin(i  ,j  ,k+1)
     4 +phin(i  ,j+1,k+1))*0.25d0
      phif=1.0d0-phis
      sgn(6,i,j,k)=sgn(6,i,j,k)
     1 -(p(i,j,k)-p(i,j+1,k)-p(i,j,k+1)+p(i,j+1,k+1))
     2 *dydzinvdt*phif*rnu00*2.0d0
      enddo
      enddo
      enddo

      call bcsg(ipara,nID,ID,ni,nj,nk,vc,dx,dy,dz,rnu00,sgn,uvwn,ftime)

      tim=frt_gettime()
      call SklCommBndCell(sgn,1,ierr)
      ftime(3)=ftime(3)+frt_spantime(tim)


      if(icherr.eq.1.and.mod(nstep,imon_t).eq.0)then
      sum1=0.0d0
      sum2=0.0d0
      do k=1,nk
      do j=1,nj
      do i=1,ni
      sum1=sum1+ sgn(1,i,j,k)+sgn(2,i,j,k)+sgn(3,i,j,k)
      sum2=sum2+(sgn(1,i,j,k)+sgn(2,i,j,k)+sgn(3,i,j,k))**2
      enddo
      enddo
      enddo

      sendbuf(1) = sum1
      recvbuf(1) = sum1
      sendbuf(2) = sum2
      recvbuf(2) = sum2

      tim=frt_gettime()
      call SklAllreduce(sendbuf,recvbuf,2,SKL_REAL8,SKL_SUM,0,ierr)
      ftime(3)=ftime(3)+frt_spantime(tim)


      sum1 = recvbuf(1)
      sum2 = recvbuf(2)

      av1=sum1/dble(vsall(1)*vsall(2)*vsall(3))
      av2=sum2/dble(vsall(1)*vsall(2)*vsall(3))

c      if( ID == 0 ) then
c      write(*,'("AV_DIAG ",20e20.10)')
c     1  time
c     2 ,av1
c     3 ,sqrt(av2)
c      endif

      rlog(10)=time
      rlog(11)=av1
      rlog(12)=sqrt(av2)

      endif

ccc 
ccc !check the residual error 
ccc

      if(icherr.eq.1) then
        call caldiv(ID,vsall,vc,ni,nj,nk,icherr,nstep,imon_t,
     1              dx,dy,dz,dt,time,uvwn,div,rlog,2,ftime)
      endif

ccc
ccc<renew new pressure
ccc

      do k=1,nk
      do j=1,nj
      do i=1,ni
      pk(i,j,k)=pk(i,j,k)+p(i,j,k)
      enddo
      enddo
      enddo
c
      do k=1,nk
      do j=1,nj
      do i=1,ni
      p(i,j,k)=pk(i,j,k)
      enddo
      enddo
      enddo

ccc
ccc<impose boundary condition
ccc

      include 'bcp.h'

      tim=frt_gettime()
      call SklCommBndCell(p,1,ierr)
      ftime(3)=ftime(3)+frt_spantime(tim)
c
      return
      end

c -------------------------------------------------------------

