      subroutine solxg(vc,ni,nj,nk,dt,dx,dy,dz,wl,
     1  uvwn,xg,yg,zg,xgn,ygn,zgn,ug,vg,wg,ng,nid,id)
c
      implicit none
      character*32 fname

cc subroutine arguments
      integer vc
      integer ng
      integer ni,nj,nk
      integer nid(ng),id
      real dt
      real dx,dy,dz,wl(3)
      real uvwn(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real xg (ng),yg (ng),zg (ng)
      real xgn(ng),ygn(ng),zgn(ng)
      real ug (ng),vg (ng),wg (ng)

cc local variables 
      integer l
      real dxg,dyg,dzg

c<velocity (u)
      dxg=0.0d0
      dyg=0.5d0*dy
      dzg=0.5d0*dz
      call inp1(vc,ni,nj,nk,ng,dx,dy,dz,
     +  uvwn,1,ug,dxg,dyg,dzg,xg,yg,zg,nid,id)
c<velocity (v)
      dxg=0.5d0*dx
      dyg=0.0d0
      dzg=0.5d0*dz
      call inp1(vc,ni,nj,nk,ng,dx,dy,dz,
     +  uvwn,2,vg,dxg,dyg,dzg,xg,yg,zg,nid,id)
c<velocity (w)
      dxg=0.5d0*dx
      dyg=0.5d0*dy
      dzg=0.0d0
      call inp1(vc,ni,nj,nk,ng,dx,dy,dz,
     +  uvwn,3,wg,dxg,dyg,dzg,xg,yg,zg,nid,id)

c<position

      do l=1,ng
      xgn(l) =xg(l)+dt*ug(l)
      ygn(l) =yg(l)+dt*vg(l)
      zgn(l) =zg(l)+dt*wg(l)
      enddo

c<collision
      do l=1,ng
c
      if(xgn(l).lt.0.0d0)then
      xgn(l)=xgn(l)+wl(1)
      endif

      if(xgn(l).gt.wl(1))then
      xgn(l)=xgn(l)-wl(1)
      endif

      if(ygn(l).lt.0.0d0)then
      ygn(l)=-ygn(l)
      endif

      if(ygn(l).gt.wl(2))then
      ygn(l)=-ygn(l)+wl(2)*2.0d0
      endif

      if(zgn(l).lt.0.0d0)then
      zgn(l)=zgn(l)+wl(3)
      endif

      if(zgn(l).gt.wl(3))then
      zgn(l)=zgn(l)-wl(3)
      endif
c
      enddo

c<renew
      do l=1,ng
c
       xg(l)=xgn(l)
       yg(l)=ygn(l)
       zg(l)=zgn(l)
c
      enddo
c
      return
      end


