      subroutine restart_uvw(outwv,uvwk,vc,ni,nj,nk)

      implicit none

      integer vc
      integer ni,nj,nk
      real uvwk (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real outwv(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

      integer i,j,k,n

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc
      do n=1,3

      outwv(n,i,j,k)=uvwk(n,i,j,k)
      
      enddo
      enddo
      enddo
      enddo

      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine restart_p(outwv,p,phi,phio,vc,ni,nj,nk)

      implicit none

      integer vc
      integer ni,nj,nk
      real p    (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phi  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phio (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real outwv(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

      integer i,j,k

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc

      outwv(1,i,j,k)=p(i,j,k)

      enddo
      enddo
      enddo

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc

      outwv(2,i,j,k)=phi(i,j,k)

      enddo
      enddo
      enddo

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc

      outwv(3,i,j,k)=phio(i,j,k)

      enddo
      enddo
      enddo

      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine restart_sgbl(outwv,sbk,vc,ni,nj,nk,flag)

      implicit none

      integer flag
      integer vc
      integer ni,nj,nk
      real sbk  (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real outwv(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

      integer i,j,k,n,nn

      if( flag.eq.1 ) then
        nn=0
      else
        nn=3
      endif

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc
      do n=1,3

      outwv(n,i,j,k)=sbk(n+nn,i,j,k)

      enddo
      enddo
      enddo
      enddo

      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine load_restart_uvw(outwv,uvwk,vc,ni,nj,nk)

      implicit none

      integer vc
      integer ni,nj,nk
      real uvwk (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real outwv(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

      integer i,j,k,n

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc
      do n=1,3

      uvwk(n,i,j,k)=outwv(n,i,j,k)

      enddo
      enddo
      enddo
      enddo

      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine load_restart_p(outwv,p,phi,phio,vc,ni,nj,nk)

      implicit none

      integer vc
      integer ni,nj,nk
      real p    (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phi  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phio (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real outwv(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

      integer i,j,k

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc

      p(i,j,k)=outwv(1,i,j,k)

      enddo
      enddo
      enddo

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc

      phi(i,j,k)=outwv(2,i,j,k)

      enddo
      enddo
      enddo

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc

      phio(i,j,k)=outwv(3,i,j,k)

      enddo
      enddo
      enddo

      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine load_restart_sgbl(outwv,sbk,vc,ni,nj,nk,flag)

      implicit none

      integer flag
      integer vc
      integer ni,nj,nk
      real sbk  (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real outwv(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

      integer i,j,k,n,nn

      if( flag.eq.1 ) then
        nn=0
      else
        nn=3
      endif

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc
      do n=1,3

      sbk(n+nn,i,j,k)=outwv(n,i,j,k)

      enddo
      enddo
      enddo
      enddo

      return
      end

